#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "gram.y"
/* $Header: /local/src/CVS/nickle/gram.y,v 1.145 2005/01/14 05:44:00 keithp Exp $ */

/*
 * Copyright © 1988-2004 Keith Packard and Bart Massey.
 * All Rights Reserved.  See the file COPYING in this directory
 * for licensing information.
 */

#include	"nickle.h"
#include	<stdio.h>

/*
 * This grammar generates 1 shift/reduce conflict and 4 reduce/reduce:
 * 
 * 2 reduce/reduce conflicts on:
 *
 *	    *int . func 
 *	    **int . func
 *
 *	Is the '*' a dereference operator or a pointer type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 * 2 reduce/reduce conflicts on:
 *
 *	   &int . func
 *	   &&int . func
 *
 *	Is the '&' a reference operator or a reference type modifier?
 *	The grammar is ordered to make this a type modifier since
 *	the other way is less common.  Use parens when you want this.
 *
 *  shift/reduce conflict in ASSIGN in initializers
 *
 *	That's because struct initializers look like assignment
 *	expressions while array initializers permit any expression.
 *	Shift yields struct initialization, so the effect is
 *	to make assignment expressions invalid in array initializers.
 *	(Of course, you can always enclose an assignment in parens.)
 *      (I can't see any obvious way to use operator precedence to
 *      get rid of this: seems like you'd need to duplicate simpleexpr
 *      with different precedence. --BCM)
 *
 */
int ignorenl;
int notCommand;
int seeComment;
NamespacePtr	LexNamespace;
int funcDepth;

void ParseError (char *fmt, ...);
void yyerror (char *msg);

typedef enum _CanonTypeResult {
    CanonTypeUndefined,
    CanonTypeForward,
    CanonTypeDefined,
} CanonTypeResult;
    
static Expr *
ParseCanonFor (Expr *expr);

static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed);

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name);

#line 72 "gram.y"
typedef union {
    int		    ints;
    Value	    value;
    Class	    class;
    ArgType	    *argType;
    Type	    *type;
    Publish	    publish;
    ExprPtr	    expr;
    Atom	    atom;
    DeclListPtr	    declList;
    MemListPtr	    memList;
    Fulltype	    fulltype;
    ArgDecl	    argDecl;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    CodePtr	    code;
    Bool	    bool;
    AtomListPtr	    atomList;
    FuncDecl	    funcDecl;
} YYSTYPE;
#line 102 "gram.c"
#define opt_typename 257
#define VAR 258
#define EXPR 259
#define ARRAY 260
#define STRUCT 261
#define UNION 262
#define ENUM 263
#define COMP 264
#define HASH 265
#define SEMI 266
#define MOD 267
#define OC 268
#define CC 269
#define DOLLAR 270
#define DOTDOTDOT 271
#define ENDFILE 272
#define GLOBAL 273
#define AUTO 274
#define STATIC 275
#define CONST 276
#define POLY 277
#define INTEGER 278
#define NATURAL 279
#define RATIONAL 280
#define REAL 281
#define STRING 282
#define FOREIGN 283
#define FILET 284
#define MUTEX 285
#define SEMAPHORE 286
#define CONTINUATION 287
#define THREAD 288
#define VOID 289
#define BOOL 290
#define FUNCTION 291
#define FUNC 292
#define EXCEPTION 293
#define RAISE 294
#define TYPEDEF 295
#define IMPORT 296
#define NEW 297
#define ANONINIT 298
#define NAMESPACE 299
#define PUBLIC 300
#define PROTECTED 301
#define EXTEND 302
#define WHILE 303
#define DO 304
#define FOR 305
#define SWITCH 306
#define BREAK 307
#define CONTINUE 308
#define RETURNTOK 309
#define FORK 310
#define CASE 311
#define DEFAULT 312
#define TWIXT 313
#define NAME 314
#define TYPENAME 315
#define NAMESPACENAME 316
#define COMMAND 317
#define NAMECOMMAND 318
#define TEN_NUM 319
#define OCTAL0_NUM 320
#define OCTAL_NUM 321
#define BINARY_NUM 322
#define HEX_NUM 323
#define TEN_FLOAT 324
#define OCTAL0_FLOAT 325
#define OCTAL_FLOAT 326
#define BINARY_FLOAT 327
#define HEX_FLOAT 328
#define CHAR_CONST 329
#define STRING_CONST 330
#define POLY_CONST 331
#define THREAD_CONST 332
#define COMMENT_CONST 333
#define VOIDVAL 334
#define BOOLVAL 335
#define DARROW 336
#define POUND 337
#define COMMA 338
#define ASSIGN 339
#define ASSIGNPLUS 340
#define ASSIGNMINUS 341
#define ASSIGNTIMES 342
#define ASSIGNDIVIDE 343
#define ASSIGNDIV 344
#define ASSIGNMOD 345
#define ASSIGNPOW 346
#define ASSIGNSHIFTL 347
#define ASSIGNSHIFTR 348
#define ASSIGNLXOR 349
#define ASSIGNLAND 350
#define ASSIGNLOR 351
#define QUEST 352
#define COLON 353
#define OR 354
#define AND 355
#define LOR 356
#define LXOR 357
#define LAND 358
#define EQ 359
#define NE 360
#define LT 361
#define GT 362
#define LE 363
#define GE 364
#define SHIFTL 365
#define SHIFTR 366
#define PLUS 367
#define MINUS 368
#define TIMES 369
#define DIVIDE 370
#define DIV 371
#define POW 372
#define STARSTAR 373
#define POW2 374
#define POW3 375
#define UNIONCAST 376
#define UMINUS 377
#define BANG 378
#define FACT 379
#define LNOT 380
#define INC 381
#define DEC 382
#define STAR 383
#define AMPER 384
#define THREADID 385
#define OS 386
#define CS 387
#define DOT 388
#define ARROW 389
#define STAROS 390
#define CALL 391
#define OP 392
#define CP 393
#define POINTER 394
#define COLONCOLON 395
#define IF 396
#define TRY 397
#define NONL 398
#define ELSE 399
#define CATCH 400
#define NL 401
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,   96,   96,   99,   99,   99,  100,  101,   98,
  102,  103,  103,  104,  104,  105,  105,   97,   97,   97,
   97,   97,   97,   97,    3,    3,    5,    5,    4,    7,
    7,    7,    6,    6,   27,   27,    1,    1,    2,    2,
   28,   28,   60,   60,  106,  107,    8,  108,  109,   14,
   14,   17,   17,   15,   15,   16,   16,   16,   16,   16,
   16,   16,   16,   16,   16,   16,   16,   16,   16,   16,
   16,  111,   16,   16,   16,   16,   70,   70,   19,   19,
   18,   12,   12,   13,    9,    9,  112,   10,   20,   20,
  110,  110,  113,   81,   82,   82,   21,   22,   22,   23,
   23,   24,   25,   25,   26,   26,   37,   37,   33,   33,
   35,   35,   40,   40,   34,   34,   36,   43,   38,   39,
   39,   39,   41,   41,   41,   42,   42,   42,   46,   46,
   46,   46,   46,   46,   45,   45,   45,   45,   45,   47,
   47,   47,   47,   47,   47,   44,   44,   51,   51,   51,
   51,   51,   51,   51,   51,   51,   51,   51,   51,   51,
   48,   48,   49,   49,   50,   50,   52,   52,   53,   53,
   54,   54,   56,   56,   55,   55,   55,   55,   57,   57,
   58,   58,   59,   59,   61,   61,   62,   62,   63,   63,
   66,   64,   64,   65,   65,   67,   67,   68,   68,   69,
   69,   71,   71,   77,   77,   72,   72,   73,   73,   75,
   75,   76,   76,   11,  114,   11,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   74,   79,   79,   78,   78,
   78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
   78,   80,   80,   80,   80,   80,   83,   83,   83,   84,
   84,   29,   29,   30,   30,   31,   32,   85,   85,   86,
   86,   87,   87,   87,   88,   89,   89,   90,   90,   91,
   91,   92,   93,   93,   94,   94,   95,   95,   95,   95,
};
short yylen[] = {                                         2,
    2,    0,    1,    3,    1,    1,    1,    0,    0,    0,
    0,    1,    0,    1,    0,    1,    0,    4,    6,    4,
    6,    6,    1,    1,    1,    0,    3,    1,    2,    1,
    1,    1,    3,    0,    2,    1,    2,    1,    1,    3,
    3,    2,    1,    1,    0,    0,    3,    2,    2,    2,
    0,    7,    9,    1,    1,    3,    9,   10,    9,    9,
   10,    2,    2,    3,    2,    1,    4,   10,    6,    6,
    7,    0,    9,    6,    2,   11,    3,    1,    1,    3,
    4,    2,    0,    7,    1,    1,    0,    2,    1,    4,
    1,    1,    0,    2,    1,    0,    3,    2,    0,    4,
    3,    3,    2,    0,    7,    3,    1,    0,    3,    1,
    3,    1,    1,    1,    4,    2,    1,    1,    4,    3,
    4,    4,    2,    2,    0,    4,    3,    2,    2,    4,
    4,    4,    4,    0,    2,    2,    2,    2,    2,    1,
    4,    4,    4,    3,    1,    1,    0,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    0,    3,    1,    3,    1,    3,    1,    4,    0,
    4,    0,    1,    0,    1,    1,    1,    1,    1,    0,
    1,    1,    1,    1,    3,    2,    3,    2,    2,    1,
    3,    2,    1,    3,    2,    2,    1,    1,    0,    1,
    0,    1,    2,    1,    3,    1,    0,    3,    1,    1,
    0,    3,    2,    3,    0,    2,    3,    7,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    3,    3,    3,    3,    3,    3,    3,    2,
    2,    3,    3,    5,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    6,    8,    8,    8,    3,    6,    2,    1,    3,
    3,    4,    4,    4,    3,    3,    1,    0,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    0,    5,
    9,    2,    1,    3,    1,    1,    0,    3,    1,    1,
    1,    1,    2,    0,    4,    3,    1,    3,    2,    1,
    1,    4,    3,    1,    3,    3,    1,    1,    1,    2,
};
short yydefred[] = {                                      2,
    0,   10,   24,   23,    1,    3,    0,    0,    0,    0,
    0,   66,    0,   45,    0,  175,  176,  177,  178,  148,
  149,  150,  151,  152,  160,  153,  154,  155,  156,  157,
  158,  159,    8,    0,  181,  182,  184,    8,    8,    8,
    8,    0,    0,    0,    0,    8,   43,   36,    0,    0,
    0,  257,  259,  258,  260,  261,  262,  264,  263,  265,
  266,  267,  268,  269,  270,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  279,    0,    8,    8,  256,
   55,   10,   54,   46,    9,  145,    0,   93,   45,    0,
    0,    0,    0,  140,    0,    0,    0,    0,   38,    0,
    0,    0,    0,    0,    6,    7,    5,    4,    0,    0,
    0,  302,  304,  303,  305,  306,  219,   48,  278,  287,
    0,    0,    0,   45,   45,   45,   45,   62,   63,    0,
    0,    0,    0,    0,  200,    0,    0,   45,   42,   10,
  206,    0,   10,    0,   25,    0,  138,    0,  139,    0,
    0,  136,    0,  137,    0,    0,    0,    0,    0,  271,
    0,    0,    0,    0,   45,    0,    0,    9,   75,   35,
    0,   37,    0,    0,    8,    0,    0,  203,    0,   45,
    0,   12,  128,    0,    0,  135,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  146,    8,    8,    8,  173,
    0,    8,   65,    0,    0,    0,  301,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  240,
  241,  227,  229,  231,    0,    0,    0,    0,    0,    0,
    0,   46,    0,    0,    8,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  117,   64,    0,
    0,    0,    0,   34,   30,   32,   31,    0,    0,    0,
    0,    0,    0,  281,    0,    0,  280,    0,    0,   79,
   83,   20,   56,   41,   86,   46,   85,    0,   95,   94,
    0,    0,    0,  120,    0,    0,    0,  276,  166,    0,
    0,    0,    0,    0,  186,    0,    0,    0,  129,  138,
  139,  136,  137,    0,    0,  127,    0,    0,    0,    0,
    0,   10,   18,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  285,  286,    0,    0,    0,
  210,    0,    0,    0,   47,   50,   45,    0,  141,    0,
  142,    0,  143,  122,    0,    0,    0,    0,    0,    0,
   14,    0,  208,    0,   27,   33,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   67,   89,   88,    0,
  119,    0,    0,  192,    0,  121,    0,    0,  337,  339,
  338,  124,  118,    0,    8,   93,    0,    0,    0,    0,
    0,  189,  185,  198,    0,  188,  144,   45,  114,    0,
    0,    0,    0,    0,    0,  126,   44,   72,    0,    0,
  283,  282,    0,  213,  284,   49,    0,    0,    0,  109,
    0,    0,    0,    0,    0,    0,    0,   21,   22,   45,
  163,   45,   45,  167,    0,   46,    0,   80,    0,   82,
    0,  196,    0,  195,  340,    0,    0,    0,    0,    0,
  319,    0,  327,    0,  334,  321,  115,    0,    0,  133,
  130,  165,  131,  132,  187,    0,    9,    0,  113,    0,
    0,    9,    0,   19,    0,  212,    0,  169,  171,   69,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  272,    0,   45,    0,  194,    0,    0,  329,  331,    0,
    0,    0,    0,    0,    0,    0,    0,  191,   46,    0,
    0,   46,   70,  111,    9,   40,   74,    0,    0,   46,
    0,   77,   46,   46,    0,    0,    0,   46,  322,    0,
   46,    0,   46,  307,    0,    0,   90,    0,  336,  316,
  317,    0,  328,    0,  318,    0,    0,  326,  325,    0,
  333,  332,  218,    0,  216,   93,   71,    0,    0,    9,
   46,    9,    9,    0,    0,   46,    0,    0,  323,  275,
  273,  308,  274,    0,   93,    0,    0,  310,    0,    0,
    9,   46,    0,   57,    9,   59,   60,    0,    0,   97,
   98,   46,   53,    0,    0,  314,    9,   73,    9,   45,
    0,   46,    0,   58,    0,  101,    9,   46,    0,  313,
   46,   68,   61,    0,    0,  102,  103,  100,   76,   84,
  312,    0,    0,  106,  311,  107,    0,    0,   46,  105,
};
short yydgoto[] = {                                       1,
   80,  435,  143,  144,  145,  146,  278,   81,  296,  297,
  539,  396,  470,  252,  253,   83,   84,   85,  291,  399,
  554,  596,  597,  612,  632,  633,   86,   87,  641,  571,
  572,  606,  261,  178,  431,  179,  657,   88,   89,  432,
  306,   90,  414,   91,  136,  186,   93,  311,  281,  313,
   94,  282,  257,  259,   95,  201,   96,   97,   98,   99,
  187,  317,  318,  301,  404,  416,  405,  426,  454,  455,
  254,  140,  141,  101,  360,  361,  102,  250,  119,  117,
  173,  300,  563,  409,  480,  481,  558,  410,  482,  483,
  528,  411,  484,  485,  486,    5,    6,    8,  108,  302,
  169,    7,  183,  382,  533,  118,  364,  103,  365,  104,
  503,  298,  174,  541,
};
short yysindex[] = {                                      0,
 -237,    0,    0,    0,    0,    0, 1220, -252, -164,  -88,
  -50,    0,  130,    0,  130,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   22,    0,    0,    0,    0,    0,    0,
    0,  -44,   15, 5119, 6271,    0,    0,    0,  -95, 6271,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 6271, 6271, 6271, 6271, 6271,
 6271, 6271, 6271, 6271,  -80,    0, 4991,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   43,    0,    0,  -17,
  101, -332, -297,    0, 6425,   82,  211,  107,    0, -236,
 6682,   -5, 1352,  108,    0,    0,    0,    0, 6425, 6425,
  114,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  118,   24,   54,    0,    0,    0,    0,    0,    0,  -88,
  -50,  122,  211,  174,    0,   66,  342,    0,    0,    0,
    0, 2002,    0,  120,    0,   48,    0,  447,    0,  447,
  447,    0,  447,    0,  447,  447,  447,  447,  447,    0,
 5631,   79, -178,   86,    0, 1484,   87,    0,    0,    0,
   94,    0,  224,  161,    0,  181,  105,    0,  162,    0,
  188,    0,    0, 5759, 3921,    0, -297,  -95, 6425, 6425,
 6425, 6425, 6425,    1,   87,    0,    0,    0,    0,    0,
 6425,    0,    0, 5119,  109, 6271,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 6271,
 6271, 6271, 6271, 6271, 6271, 6271, 6271, 6271, 6271, 6271,
 6271, 6271, 6271, 6271, 6271, 6271, 6271, 6271, 6271,    0,
    0,    0,    0,    0, 6271,  189,  198, 6271, 6271, 6271,
 6271,    0, 1352,  247,    0,  114,  249,  114,  251,  178,
  252,  132, 6271,  133, 1352,  135,  136,    0,    0,  140,
  267, 6271,  267,    0,    0,    0,    0,  139, 6271,  -34,
  -42,  151, 6464,    0,  226,    0,    0,  150, 1352,    0,
    0,    0,    0,    0,    0,    0,    0,  276,    0,    0,
  152, 6425,  154,    0, 5887,  209,  157,    0,    0,   35,
  169,  220,  -40,  173,    0,  250,  168, -226,    0,    0,
    0,    0,    0,  170,   94,    0,  254, 6384,   22,   87,
   67,    0,    0,  272, 6518, 2114, 2223, 2332, 2441, 2550,
  609,  609,  760,  760,  760,  760,  949,  949,  912,  912,
  272,  272,  272,  272,  183,    0,    0,  184, 1874,  180,
    0, 6682, 6682,  305,    0,    0,    0,  317,    0,  320,
    0,  114,    0,    0,  199, 5119,  290, 5119, 5119, 5119,
    0,  193,    0,  195,    0,    0,  213,  233,  222,  223,
 6271,  227,  345, 5119,  348,  219,    0,    0,    0,  282,
    0,  308,    0,    0, -150,    0, 5247, 6682,    0,    0,
    0,    0,    0,  122,    0,    0, -297, -297,  352, -297,
 -297,    0,    0,    0, 6425,    0,    0,    0,    0,    0,
  358,  287,   34,  291,  364,    0,    0,    0,  230, 6271,
    0,    0, 6271,    0,    0,    0,  240, 6425, 6425,    0,
  367,  243,  245,  374,  248,  255,  376,    0,    0,    0,
    0,    0,    0,    0, 6271,    0,  259,    0,   22,    0,
 6271,    0, 6425,    0,    0,  304, 5887,  -80, 6573,  318,
    0,  319,    0,  321,    0,    0,    0,  262,    0,    0,
    0,    0,    0,    0,    0,  271,    0,   34,    0,  401,
   22,    0,  420,    0,  342,    0, 5119,    0,    0,    0,
 1352, 5119, 5119, 1352,  276, 5119,  421,  422,  423,  447,
    0, 1352,    0, 1617,    0, 5887, 6682,    0,    0,  355,
 5887, 5887,  443, 6015,  424,  378,  453,    0,    0,  386,
  276,    0,    0,    0,    0,    0,    0, 1352,  333,    0,
  336,    0,    0,    0,   73,  340, 5375,    0,    0, 6143,
    0, 5503,    0,    0,  337,  157,    0, 6682,    0,    0,
    0,  399,    0, 6682,    0,  469, 6573,    0,    0,  304,
    0,    0,    0, 6271,    0,    0,    0,  471,  276,    0,
    0,    0,    0, 5119,  388,    0,   73, 1352,    0,    0,
    0,    0,    0, 1352,    0,  357,  355,    0, 6682,  476,
    0,    0,   99,    0,    0,    0,    0,  392, 1352,    0,
    0,    0,    0,  276, -216,    0,    0,    0,    0,    0,
  393,    0,   99,    0, 1352,    0,    0,    0, 5887,    0,
    0,    0,    0,  433, 1352,    0,    0,    0,    0,    0,
    0,  480,  436,    0,    0,    0,  398, 1352,    0,    0,
};
short yyrindex[] = {                                      0,
 1088,    0,    0,    0,    0,    0,  102,    0,    0,  446,
  450,    0,    0,    0, 1554,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -225,  465,    0,    0,    0, 1682, -234,
 -209,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  465,  465,  465,  465,  465,
  465,  465,  465,  465,    0,    0,  465,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -192,  142,    0, -248,  464,  911,    0,    0,  389,
 -255,  -66,  283,    0,    0,    0,    0,    0, -142,   17,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  956,    0,    0,  531,  334,    0,    0,    0,
    0, -254,    0, -233,    0,    0,    0, 2066,    0, 2176,
 2286,    0, 2396,    0, 2506, 2616, 2726, 2836, 2946,    0,
  465,    0,   -1,    0,    0,  102,  789,    0,    0,    0,
 1682,    0, -184, -219,    0,    0, -132,    0, -202,    0,
    0,    0,    0, -179,    0,    0,  142,    0,    0,    0,
    0,    0,    0,    0,   -6,    0,    0,    0,    0,    0,
 -248,    0,    0,  465,    0,  465,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  465,
  465,  465,  465,  465,  465,  465,  465,  465,  465,  465,
  465,  465,  465,  465,  465,  465,  465,  465,  465,    0,
    0,    0,    0,    0,  465,    0,    0,  465, -253,  465,
  465,    0,  315,    0,    0,    0,    0,    0,    0,   33,
    0,    0, -250,    0,  102,    0,    0,    0,    0,    0,
  429,  465,  429,    0,    0,    0,    0, -257, -212,  531,
    0,    0,  437,    0,    0,   38,    0,    0,  283,    0,
    0,    0,    0,    0,    0,    0,    0,  493,    0,    0,
    0, -278,    0,    0,  465,    7,    0,    0,    0,  531,
    0,  444,    0,    0,    0,  -68,    0,  441,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   -6,
    0,    0,    0, 3166,    0, 4849, 4759, 4738, 4646, 4623,
 4500, 4526, 4104, 4203, 4302, 4401, 3902, 4003, 3696, 3799,
 3272, 3378, 3484, 3590,    0,    0,    0,    0,  441,    0,
    0, -245, -180,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  465,    0, -176,  465, -225,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  465, 6628,    0,  465,    0,  492,    0,    0,    0,    0,
    0,    0,   12,    0,  441,    0,  465,  -19,    0,    0,
    0,    0,    0,    0,    0,    0,  142,  142,    0,  142,
  142,    0,    0,    0,    0,    0,    0,    0,    0, -205,
    0,  572,    0,  574,    0,    0,    0,    0,    0,  465,
    0,    0,  465,    0,    0,    0,    0, -142,   17,    0,
    0,    0,    0,  448,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  465,    0,    0,    0,    0,    0,
  465,    0,  528,    0,    0, 1744,  465,  529,   23,  138,
    0,  575,    0,  575,    0,    0,    0,    0,  -64,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 4869,    0,  465,    0,    0,    0,
  102,  465, -176,  102,    0, -198, 1810,    0, 1938, 3056,
    0,  102,    0,    0,    0,  465, -119,    0,    0,    0,
  465,   40,  576,   32,    0,  577,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  283,    0,    0,
    0,    0,    0,    0,  579,    0,  465,    0,    0,  465,
    0,  465,    0,    0,  634,    0,    0,  -60,    0,    0,
    0,  462,    0,   23,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  465,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  465,    0,    0,  579,  102,    0,    0,
    0,    0,    0,  102,    0,    0,    0,    0,  -73,    0,
    0,    0,  582,    0,    0,    0,    0,    0,  315,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  582,    0,  315,    0,    0,    0,  465,    0,
    0,    0,    0,    0,  315,    0,    0,    0,    0,    0,
    0,    0,  499,    0,    0,    0,    0,  315,    0,    0,
};
short yygindex[] = {                                      0,
  -26,  353,    0,    0,  581,    0,    0,  -74,    0,    0,
    0,    0,    0, -243,   -3,  687,    0,    0,    0,    0,
    0,  260,    0,    0,  225,    0,    0,  270,    0,  256,
    0,    0, -227,  442, -231,    0,    0,    0,    0,    0,
    0,  -39,    0,  -82,   -7, -169,    0,    0,  675,    0,
    0, -131,  414,  415,  179,    0,    0,   41,    0,  -72,
  370,  452,    0,  454,  394,  302,    0, -357,  -38,  362,
   10,  608,  607,    5,    0,  438,    0,    0,    0,  867,
 -415,    0,    0,  -81,    0, -498,    0,  366,    0,  351,
  356,    0,    0,  350, -265,    0,    0,  -75,    0,   91,
 -146,    0, -151,  619,  -55,   36,   27, -492, -317,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 7074
short yytable[] = {                                      92,
  489,  444,  162,   82,  132,  134,  167,  122,   29,  366,
  204,  209,  195,  105,  172,  292,  100,  319,    2,  106,
  217,  293,  555,  217,  205,  217,  256,  258,  368,  203,
  370,  207,   28,  575,    3,  147,   92,  132,  147,  412,
  201,  147,  147,  326,  424,  395,   96,  474,   96,  137,
  172,   14,  314,  135,  142,  181,   26,  147,  147,  149,
  113,  152,  154,  125,  271,  147,  147,  273,  182,  163,
  148,  150,  151,  153,  155,  156,  157,  158,  159,  147,
   29,  204,  204,   87,  133,  205,  164,  196,  184,  201,
  217,  217,  217,  147,  185,   92,  613,  204,   13,  146,
  204,  196,  196,  109,   34,   34,   34,  217,   36,   36,
  168,  425,  147,  355,  193,  147,  358,  133,  330,   96,
  424,   13,  639,  121,  175,  164,  170,  466,  124,  125,
  126,  127,  113,  117,  125,  125,  138,  204,  209,  211,
  651,  217,  207,   29,  450,  204,  209,  217,  107,  330,
  125,  400,  147,  280,   87,  217,  205,  205,   92,  264,
  265,  266,  267,    4,  132,  283,  207,   28,  165,  166,
  610,  147,  205,  270,  164,  576,  310,  316,  436,  110,
   36,  320,  321,  322,  323,  324,   36,  473,  283,  624,
  125,   26,  214,  196,  201,  214,   92,  214,  125,  202,
  288,  500,  190,  215,  117,  117,  117,  162,  335,  285,
  334,  529,  205,  332,  286,  307,  201,  111,  330,  402,
  205,  128,  182,  398,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  133,   92,  123,  490,  491,  283,
  493,  494,  283,  359,  362,  363,  439,   92,  438,  464,
  569,  377,  214,  214,  214,  529,  544,  142,  117,  190,
  202,  152,  116,  176,    9,  200,  142,  335,  620,  214,
  129,   92,  197,  153,   13,  172,  202,  327,  328,  329,
  146,  320,  331,  320,  403,  388,  177,  419,  110,  139,
   16,  110,  434,  123,  588,   45,  160,   13,   16,  408,
   16,  200,   13,  214,  646,  170,  325,  123,  123,  214,
  433,  393,  397,  147,  190,  146,  202,  214,  144,  144,
  147,  147,  251,  123,  202,   47,  132,   49,  132,  132,
  132,  457,  540,  116,  389,  367,  420,  429,  499,  197,
  543,  144,  387,  181,  132,  547,   47,  170,  171,  116,
  320,  275,  276,  277,  194,  256,  258,   47,   92,  171,
   92,   92,   92,  123,  197,  636,  198,  199,  194,  194,
   47,  123,  437,  594,  595,  452,   92,  135,  456,  135,
  402,  648,  180,  147,  180,  283,  180,  180,  587,  116,
  180,  654,  447,  467,  197,  202,   17,  116,   17,  630,
  631,  479,  134,  255,  659,  263,  133,  316,  133,  133,
  133,  417,  181,  144,  144,  144,  535,  260,  537,  144,
  144,  262,  134,  134,  133,  268,  561,  564,  144,  269,
  196,  196,  523,  614,  505,  616,  617,  359,  112,  113,
  114,  115,  116,  181,  194,  134,  134,  274,  194,  194,
  194,  194,  194,  496,  628,  403,  585,  132,  634,  520,
  194,  284,  132,  132,  434,  524,  132,  556,  287,  134,
  642,  527,  643,   16,   17,   18,   19,  182,  294,  295,
  649,   81,  521,  299,  303,  517,  304,  518,  519,   92,
  305,  308,  356,   92,   92,   92,   92,  550,   92,  333,
  553,  357,  203,  530,   92,  372,  549,  369,  565,  371,
  373,  551,  135,  374,  376,  135,  378,  379,  134,  134,
  568,  380,  381,  386,  134,  527,  574,  390,  577,  392,
   92,  394,  134,   14,  401,  406,  413,  133,  415,  638,
  640,   51,  133,  133,  132,  418,  133,  388,  566,  421,
  423,  577,  427,  422,  574,  583,  574,  428,  586,  441,
  442,  194,  445,  446,  147,  180,  590,  180,  180,  592,
  593,  180,  448,   51,  600,  449,   92,  601,  609,  603,
   92,  451,  453,  458,  622,  459,   92,  194,  123,  232,
  623,  461,  232,  618,  232,  460,  147,  180,  206,  180,
  180,   92,  407,  180,  462,  463,  468,  615,  469,  465,
  471,  472,  492,  497,  498,   51,   51,   92,  501,  502,
  504,  507,  510,   52,  133,  511,  512,   92,  629,  513,
  514,  516,  526,  574,  239,  240,  241,  515,  637,  242,
   92,  522,  243,  244,  538,  532,  534,  245,  536,  246,
  247,  248,  185,  249,  650,  644,  545,  652,  570,  232,
  232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  232,  660,  232,  548,  557,  560,
  562,  580,  579,  220,  194,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  424,  239,  240,  241,  194,  194,  242,
  232,  582,  243,  244,  584,  589,  232,  245,  591,  246,
  247,  248,  598,  249,  232,  604,  607,  608,  123,  611,
  619,  627,  194,  625,  635,  645,  653,   81,  655,  656,
  658,   91,   81,   81,   81,   92,  147,   81,   81,   81,
   81,   81,  183,   81,   81,   81,   81,   81,   81,   81,
  123,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   13,   10,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,   81,   81,   81,   81,   81,   81,   81,   81,
   81,   81,  146,  168,  242,   81,   81,  243,  244,   15,
  161,    9,  245,  199,  246,  247,  248,  112,  249,   39,
   78,  147,   45,   17,  199,   16,   81,   99,  315,   81,
  104,  108,  290,  546,  385,  487,  621,  647,  312,   81,
   81,  508,  626,  509,   81,  542,  525,  605,  488,   81,
  375,   81,   81,   81,  552,  206,  495,   81,  383,   81,
  506,  120,  559,   81,  578,  581,  573,   81,   81,   52,
   81,  384,   81,    0,   52,   52,   52,    0,    0,   52,
   52,   52,   52,   52,    0,   52,   52,   52,   52,   52,
   52,   52,    0,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
    0,    0,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,   52,   52,   52,   52,   52,   52,
   52,   52,   52,   52,    0,    0,    0,   52,   52,  228,
  229,  230,  231,  232,  233,  234,  235,  236,  237,  238,
    0,  239,  240,  241,    0,    0,  242,    0,   52,  243,
  244,   52,    0,    0,  245,    0,  246,  247,  248,    0,
  249,   52,   52,    0,    0,    0,   52,    0,    0,    0,
    0,   52,    0,   52,   52,   52,    0,    0,    0,   52,
    0,   52,    0,    0,    0,   52,  206,    0,    0,   52,
   52,    0,    0,   52,   52,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   13,    0,    0,    0,    0,   13,
   13,   13,    0,    0,   13,   13,   13,    0,   13,    0,
   13,   13,   13,   13,   13,   13,   13,    0,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,    0,    0,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,    0,
    0,   13,   13,   13,   13,   13,   13,   13,   13,   13,
   13,   13,   13,   13,   13,   13,   13,   13,   13,    0,
    0,    0,   13,   13,  232,  233,  234,  235,  236,  237,
  238,    0,  239,  240,  241,    0,    0,  242,    0,    0,
  243,  244,    0,   13,    0,  245,   13,  246,  247,  248,
    0,  249,    0,    0,    0,    0,   13,   13,    0,    0,
    0,   13,    0,    0,    0,    0,   13,    0,   13,   13,
   13,  174,  174,  174,   13,    0,   13,    0,  206,    0,
   13,    0,    0,    0,   13,   13,    0,  174,  174,    0,
  174,  174,  174,  174,  174,  174,  174,  174,  174,  174,
  174,  174,    0,  179,    0,  179,  179,    0,    0,  179,
    0,    0,    0,    0,    0,  206,  174,  174,  174,    0,
    0,    0,    0,    0,  174,  174,  174,    0,    0,    0,
    0,    0,  174,  174,    0,  174,  174,  174,  174,  174,
  174,  174,  174,  174,  174,  174,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  174,    0,    0,  174,  174,
  174,  174,    0,    0,    0,    0,    0,    0,    0,  174,
  236,  237,  238,  174,  239,  240,  241,    0,    0,  242,
    0,    0,  243,  244,    0,    0,    0,  245,    0,  246,
  247,  248,  174,  249,    0,    0,    0,    0,    0,    0,
  174,  174,    0,  174,    0,  234,  235,  236,  237,  238,
    0,  239,  240,  241,  174,    0,  242,    0,  174,  243,
  244,    0,    0,    0,  245,    0,  246,  247,  248,    0,
  249,    0,    0,    0,    0,    0,    0,  174,   11,   11,
   11,    0,    0,   11,   11,   11,  174,   11,    0,    0,
   11,   11,   11,   11,   11,   11,    0,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,    0,    0,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,    0,    0,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,    0,    0,
    0,   11,   11,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   11,    0,    0,   11,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   11,   11,    0,    0,    0,
   11,    0,    0,    0,    0,   11,    0,   11,   11,   11,
    0,    0,    0,   11,    0,   11,    0,    0,    0,   11,
    9,   10,   11,   11,   11,   12,   13,   14,    0,   15,
    0,    0,   16,   17,   18,   19,   20,   21,    0,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
   33,    0,    0,   34,    0,    0,    0,    0,    0,   35,
   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
    0,    0,   46,   47,   48,   49,   50,   51,   52,   53,
   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
    0,    0,    0,   64,   65,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   66,    0,    0,   67,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   68,   69,    0,
    0,    0,   70,    0,    0,    0,    0,   71,    0,   72,
   73,   74,    0,    0,    0,   75,    0,   76,    0,    0,
    0,   77,    9,   10,   11,   78,   79,   12,   13,   14,
    0,   15,    0,    0,   16,   17,   18,   19,   20,   21,
    0,   22,   23,   24,   25,   26,   27,   28,   29,   30,
   31,   32,   33,    0,    0,   34,    0,    0,    0,    0,
    0,   35,   36,   37,   38,   39,   40,   41,   42,   43,
   44,   45,    0,    0,   46,   47,   48,   49,    0,    0,
   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
   62,   63,    0,    0,    0,   64,   65,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   66,    0,    0,   67,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   68,
   69,    0,    0,    0,   70,    0,    0,    0,    0,   71,
    0,   72,   73,   74,    0,    0,    0,   75,    0,   76,
    0,    0,    0,   77,    9,   10,   11,   78,   79,   12,
   13,  289,    0,   15,    0,    0,   16,   17,   18,   19,
   20,   21,    0,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,   33,    0,    0,   34,    0,    0,
    0,    0,    0,   35,   36,   37,   38,   39,   40,   41,
   42,   43,   44,   45,    0,    0,   46,   47,   48,   49,
    0,    0,   52,   53,   54,   55,   56,   57,   58,   59,
   60,   61,   62,   63,    0,    0,    0,   64,   65,  288,
  288,    0,  288,    0,  288,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   66,    0,
    0,   67,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,   69,    0,    0,    0,   70,    0,    0,    0,
    0,   71,    0,   72,   73,   74,    0,    0,    0,   75,
    0,   76,    0,    0,    0,   77,    0,    0,    0,   78,
   79,    0,  567,  206,    0,    0,    0,    0,    0,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  288,  288,  288,  288,  288,  288,  288,
  288,  288,  288,  288,  288,    0,  288,  288,  288,    0,
    0,  288,    0,    0,  288,  288,    0,    0,    0,  288,
  288,  288,  288,  288,    0,  288,  288,   44,   44,    0,
   44,    0,   44,    0,  288,  207,  208,  209,  210,  211,
  212,  213,  214,  215,  216,  217,  218,  219,  220,    0,
  221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
  231,  232,  233,  234,  235,  236,  237,  238,    0,  239,
  240,  241,    0,    0,  242,    0,    0,  243,  244,    0,
    0,    0,  245,    0,  246,  247,  248,    0,  249,    0,
   43,    0,   43,    0,   43,    0,    0,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,    0,   44,   44,   44,    0,    0,   44,
    0,    0,   44,   44,    0,    0,    0,   44,   44,   44,
   44,   44,    0,   44,   44,  324,  324,    0,  324,   43,
  324,   43,   44,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,    0,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,    0,   43,   43,   43,    0,
    0,   43,    0,    0,   43,   43,    0,    0,    0,   43,
    0,   43,   43,   43,    0,   43,    0,    0,    0,    0,
  206,    0,    0,    0,  424,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
  324,  324,  324,  324,  324,  324,  324,  324,  324,  324,
  324,    0,  324,  324,  324,    0,    0,  324,    0,    0,
  324,  324,    0,    0,    0,  324,  324,  324,  324,  324,
    0,  324,  324,  309,  309,    0,  309,    0,  309,    0,
  324,  443,  207,  208,  209,  210,  211,  212,  213,  214,
  215,  216,  217,  218,  219,  220,    0,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
  234,  235,  236,  237,  238,    0,  239,  240,  241,    0,
    0,  242,    0,    0,  243,  244,    0,    0,    0,  245,
    0,  246,  247,  248,    0,  249,    0,    0,  206,    0,
    0,    0,    0,  309,  309,  309,  309,  309,  309,  309,
  309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
  309,  309,  309,  309,  309,  309,  309,  309,  309,  309,
  309,  309,  309,  309,  309,  309,  309,  309,  309,    0,
  309,  309,  309,    0,    0,  309,    0,    0,  309,  309,
    0,    0,    0,  309,  309,  309,  309,  309,    0,  309,
  309,  223,  223,    0,  223,    0,  223,    0,  309,  272,
  207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,    0,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,    0,  239,  240,  241,    0,    0,  242,
  206,    0,  243,  244,    0,    0,    0,  245,    0,  246,
  247,  248,    0,  249,    0,    0,    0,    0,    0,    0,
    0,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,  223,  223,  223,
  223,  223,  223,  223,  223,  223,  223,    0,  223,  223,
  223,  222,  222,    0,  222,    0,  222,    0,    0,    0,
    0,    0,  223,    0,    0,    0,    0,    0,  223,    0,
    0,    0,    0,    0,    0,    0,  223,    0,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
  234,  235,  236,  237,  238,    0,  239,  240,  241,  206,
    0,  242,    0,    0,  243,  244,    0,    0,    0,  245,
    0,  246,  247,  248,    0,  249,    0,    0,    0,    0,
    0,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
  222,  222,  222,  222,  222,  222,  222,    0,  222,  222,
  222,  224,  224,    0,  224,    0,  224,    0,    0,    0,
    0,    0,  222,    0,    0,    0,    0,    0,  222,    0,
    0,    0,    0,    0,    0,    0,  222,    0,  223,  224,
  225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241,  206,    0,
  242,    0,    0,  243,  244,    0,    0,    0,  245,    0,
  246,  247,  248,    0,  249,    0,    0,    0,    0,    0,
    0,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,  224,  224,  224,
  224,  224,  224,  224,  224,  224,  224,    0,  224,  224,
  224,  220,  220,    0,  220,    0,  220,    0,    0,    0,
    0,    0,  224,    0,    0,    0,    0,    0,  224,    0,
    0,    0,    0,    0,    0,    0,  224,    0,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,    0,  239,  240,  241,  206,    0,  242,
    0,    0,  243,  244,    0,    0,    0,  245,    0,  246,
  247,  248,    0,  249,    0,    0,    0,    0,    0,    0,
    0,  220,  220,  220,  220,  220,  220,  220,  220,  220,
  220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
  220,  220,  220,  220,  220,  220,  220,  220,  220,  220,
  220,  220,  220,  220,  220,  220,  220,    0,  220,  220,
  220,  221,  221,    0,  221,    0,  221,    0,    0,    0,
    0,    0,  220,    0,    0,    0,    0,    0,  220,    0,
    0,    0,    0,    0,    0,    0,  220,    0,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
  237,  238,    0,  239,  240,  241,  206,    0,  242,    0,
    0,  243,  244,    0,    0,    0,  245,    0,  246,  247,
  248,    0,  249,    0,    0,    0,    0,    0,    0,    0,
    0,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,    0,  221,  221,
  221,  226,  226,    0,  226,    0,  226,    0,    0,    0,
    0,    0,  221,    0,    0,    0,    0,    0,  221,    0,
    0,    0,    0,    0,    0,    0,  221,    0,  226,  227,
  228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
  238,    0,  239,  240,  241,    0,    0,  242,    0,    0,
  243,  244,    0,    0,    0,  245,    0,  246,  247,  248,
    0,  249,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,  226,  226,  226,
  226,  226,  226,  226,  226,  226,  226,    0,  226,  226,
  226,  225,  225,    0,  225,    0,  225,    0,    0,    0,
    0,    0,  226,    0,    0,    0,    0,    0,  226,    0,
    0,    0,    0,    0,    0,    0,  226,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
  225,  225,  225,  225,  225,  225,  225,    0,  225,  225,
  225,  228,  228,    0,  228,    0,  228,    0,    0,    0,
    0,    0,  225,    0,    0,    0,    0,    0,  225,    0,
    0,    0,    0,    0,    0,    0,  225,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
  228,  228,  228,  228,  228,  228,  228,    0,  228,  228,
  228,  230,  230,    0,  230,    0,  230,    0,    0,    0,
    0,    0,  228,    0,    0,    0,    0,    0,  228,    0,
    0,    0,    0,    0,    0,    0,  228,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,  230,  230,  230,  230,  230,  230,
  230,  230,  230,  230,  230,  230,  230,    0,  230,  230,
  230,  277,  277,    0,  277,    0,  277,    0,    0,    0,
    0,    0,  230,    0,    0,    0,    0,    0,  230,    0,
    0,    0,    0,    0,    0,    0,  230,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,  277,  277,  277,
  277,  277,  277,  277,  277,  277,  277,    0,  277,  277,
  277,  238,  238,    0,  238,    0,  238,    0,    0,    0,
    0,    0,  277,    0,    0,    0,    0,    0,  277,    0,
    0,    0,    0,    0,    0,    0,  277,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  235,  235,    0,
  235,    0,  235,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  238,    0,    0,    0,    0,    0,  238,    0,
    0,    0,    0,    0,    0,    0,  238,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  236,  236,    0,  236,    0,  236,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  235,    0,
    0,    0,    0,    0,  235,    0,    0,    0,    0,    0,
    0,    0,  235,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  237,
  237,    0,  237,    0,  237,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  236,    0,    0,    0,    0,    0,
  236,    0,    0,    0,    0,    0,    0,    0,  236,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  239,  239,    0,  239,    0,
  239,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  237,    0,    0,    0,    0,    0,  237,    0,    0,    0,
    0,    0,    0,    0,  237,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  233,    0,    0,  233,    0,  233,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  239,    0,    0,    0,
    0,    0,  239,    0,    0,    0,    0,    0,    0,    0,
  239,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  234,    0,    0,  234,    0,  234,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  233,    0,    0,    0,    0,    0,  233,    0,
    0,    0,    0,    0,    0,    0,  233,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  242,    0,    0,
  242,    0,  242,    0,    0,    0,    0,    0,    0,    0,
    0,    9,  130,  131,    0,  234,    0,    0,    0,    0,
    0,  234,    0,    0,    0,    0,    0,   20,   21,  234,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   48,  188,  242,  242,  242,
  242,  242,  242,  242,  242,  242,  242,  242,  242,  242,
  242,  242,  242,  242,  242,  242,  242,  242,  242,  242,
  242,  242,  242,  242,  242,  242,  242,  242,  243,    0,
    0,  243,    0,  243,    0,  189,    0,    0,  190,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  242,  191,
    0,    0,    0,  192,  242,    0,    0,    0,    0,    0,
    0,    0,  242,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  193,  315,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  252,
    0,    0,  252,    0,  252,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  243,
    0,    0,    0,    0,    0,  243,    0,    0,    0,    0,
    0,    0,    0,  243,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  253,    0,
    0,  253,    0,  253,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  252,    0,    0,    0,    0,    0,  252,    0,    0,    0,
    0,    0,    0,    0,  252,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  253,  253,  254,    0,    0,
  254,    0,  254,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  253,
    0,    0,    0,    0,    0,  253,    0,    0,    0,    0,
    0,    0,    0,  253,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  255,    0,    0,  255,
    0,  255,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  254,    0,
    0,    0,    0,    0,  254,    0,    0,    0,    0,    0,
    0,    0,  254,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  250,    0,    0,  250,    0,
  250,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  255,    0,    0,
    0,  251,    0,  255,  251,    0,  251,    0,    0,    0,
    0,  255,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  250,  250,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
    0,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  251,  250,    0,  246,    0,
    0,  246,  250,  246,    0,    0,    0,    0,    0,    0,
  250,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  245,  251,    0,  245,    0,  245,    0,  251,    0,
    0,    0,    0,    0,    0,    0,  251,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
  246,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  247,    0,    0,  247,    0,  247,  246,
    0,    0,    0,    0,    0,  246,    0,    0,    0,    0,
    0,    0,    0,  246,  248,    0,    0,  248,    0,  248,
    0,    0,  245,    0,    0,    0,    0,    0,  245,    0,
    0,    0,    0,    0,    0,    0,  245,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  248,  249,    0,    0,  249,    0,  249,
    0,    0,    0,    0,  247,    0,    0,    0,    0,    0,
  247,    0,    0,    0,  244,    0,    0,  244,  247,  244,
    0,    0,    0,    0,    0,  248,    0,    0,    0,    0,
    0,  248,    0,    0,    0,    0,    0,    0,    0,  248,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  249,  249,  249,  249,  249,  249,
  249,  249,  249,  249,  249,  249,  249,  249,  249,  249,
  249,  249,  249,    0,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
    0,  244,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  249,    0,    0,    0,    0,
    0,  249,    0,    0,    0,    0,    0,    0,    0,  249,
    0,    9,  130,  131,    0,  244,    0,   13,   14,    0,
   15,  244,    0,   16,   17,   18,   19,   20,   21,  244,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   35,   36,    0,    0,    0,    0,    0,    0,    0,    0,
   45,    0,    0,    0,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,    0,   64,   65,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,  161,    0,   76,    9,
  130,  131,   77,    0,    0,   13,    0,    0,   15,    0,
    0,   16,   17,   18,   19,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   35,   36,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   66,    0,    0,   67,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   68,   69,    0,    0,
    0,   70,    0,    0,    0,    0,   71,    0,   72,   73,
   74,    0,    0,    0,   75,    0,   76,    9,  130,  131,
   77,    0,    0,   13,  407,  475,   15,    0,    0,    0,
    0,    0,    0,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   45,    0,    0,    0,
  476,   48,   49,    0,    0,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,    0,
   64,   65,  477,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   66,    0,    0,   67,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   68,   69,    0,    0,    0,   70,
    0,    0,    0,    0,   71,    0,   72,   73,   74,    0,
    0,    0,  478,    0,   76,    9,  130,  131,   77,    0,
    0,   13,    0,  599,   15,    0,    0,    0,    0,    0,
    0,   20,   21,    0,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   45,    0,    0,    0,   47,   48,
   49,    0,    0,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,    0,    0,    0,   64,   65,
  477,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   66,
    0,    0,   67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   68,   69,    0,    0,    0,   70,    0,    0,
    0,    0,   71,    0,   72,   73,   74,    0,    0,    0,
   75,    0,   76,    9,  130,  131,   77,    0,    0,   13,
  407,  602,   15,    0,    0,    0,    0,    0,    0,   20,
   21,    0,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   45,    0,    0,    0,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,    0,    0,    0,   64,   65,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   66,    0,    0,
   67,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   68,   69,    0,    0,    0,   70,    0,    0,    0,    0,
   71,    0,   72,   73,   74,    0,    0,    0,  478,    0,
   76,    9,  130,  131,   77,    0,    0,   13,    0,    0,
   15,    0,    0,    0,    0,    0,    0,   20,   21,    0,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   45,    0,    0,    0,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,    0,   64,   65,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,  279,
    0,    0,    0,   70,    0,    0,    0,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,  160,   76,    9,
  130,  131,   77,    0,    0,   13,    0,    0,   15,  309,
    0,    0,    0,    0,    0,   20,   21,    0,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   45,    0,
    0,    0,   47,   48,   49,    0,    0,   52,   53,   54,
   55,   56,   57,   58,   59,   60,   61,   62,   63,    0,
    0,    0,   64,   65,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   66,    0,    0,   67,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   68,  279,    0,    0,
    0,   70,    0,    0,    0,    0,   71,    0,   72,   73,
   74,    0,    0,    0,   75,    0,   76,    9,  130,  131,
   77,    0,    0,   13,  407,    0,   15,    0,    0,    0,
    0,    0,    0,   20,   21,    0,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   45,    0,    0,    0,
   47,   48,   49,    0,    0,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,   62,   63,    0,    0,    0,
   64,   65,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   66,    0,    0,   67,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   68,   69,    0,    0,    0,   70,
    0,    0,    0,    0,   71,    0,   72,   73,   74,    0,
    0,    0,   75,    0,   76,    9,  130,  131,   77,    0,
    0,   13,    0,    0,   15,    0,    0,    0,    0,    0,
    0,   20,   21,    0,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   45,    0,    0,    0,   47,   48,
   49,    0,    0,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,    0,    0,    0,   64,   65,
  477,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   66,
    0,    0,   67,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   68,   69,    0,    0,    0,   70,    0,    0,
    0,    0,   71,    0,   72,   73,   74,    0,    0,    0,
   75,    0,   76,    9,  130,  131,   77,    0,    0,   13,
  407,    0,   15,    0,    0,    0,    0,    0,    0,   20,
   21,    0,   22,   23,   24,   25,   26,   27,   28,   29,
   30,   31,   32,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   45,    0,    0,    0,   47,   48,   49,    0,
    0,   52,   53,   54,   55,   56,   57,   58,   59,   60,
   61,   62,   63,    0,    0,    0,   64,   65,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   66,    0,    0,
   67,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   68,   69,    0,    0,    0,   70,    0,    0,    0,    0,
   71,    0,   72,   73,   74,    0,    0,    0,  478,    0,
   76,    9,  130,  131,   77,    0,    0,   13,    0,    0,
   15,    0,    0,    0,    0,    0,    0,   20,   21,    0,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   45,    0,    0,    0,   47,   48,   49,    0,    0,   52,
   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
   63,    0,    0,    0,   64,   65,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   66,    0,    0,   67,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   68,   69,
    0,    0,    0,   70,    9,  130,  131,    0,   71,    0,
   72,   73,   74,    0,    0,    0,   75,    0,   76,    0,
   20,   21,   77,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    9,  130,  131,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  429,  430,  188,
    0,   20,   21,    0,   22,   23,   24,   25,   26,   27,
   28,   29,   30,   31,   32,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  206,    0,    0,    0,    0,    0,    0,    0,  189,   48,
  188,  190,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  191,    0,    0,    0,  192,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  193,    0,    0,    0,  189,
    0,    0,  190,    0,  206,    0,    0,    0,    0,    0,
    0,    0,    0,  191,    0,    0,    0,  192,    0,    0,
    0,  391,  207,  208,  209,  210,  211,  212,  213,  214,
  215,  216,  217,  218,  219,  220,  193,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
  234,  235,  236,  237,  238,    0,  239,  240,  241,  206,
    0,  242,    0,    0,  243,  244,    0,    0,    0,  245,
    0,  246,  247,  248,    0,  249,  207,  208,  209,  210,
  211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  440,  221,  222,  223,  224,  225,  226,  227,  228,  229,
  230,  231,  232,  233,  234,  235,  236,  237,  238,    0,
  239,  240,  241,    0,  276,  242,    0,    0,  243,  244,
    0,    0,    0,  245,    0,  246,  247,  248,  531,  249,
    0,  207,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,    0,  221,  222,  223,  224,
  225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241,  206,    0,
  242,    0,    0,  243,  244,    0,    0,    0,  245,    0,
  246,  247,  248,    0,  249,  276,  276,  276,  276,  276,
  276,  276,  276,  276,  276,  276,  276,  276,  276,  276,
    0,  276,  276,  276,  276,  276,  276,  276,  276,  276,
  276,  276,  276,  276,  276,  276,  276,  276,  276,    0,
  276,  276,  276,    0,    0,  276,    0,    0,  276,  276,
    0,    0,    0,  276,    0,  276,  276,  276,    0,  276,
  207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,    0,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,    0,  239,  240,  241,    0,    0,  242,
    0,    0,  243,  244,    0,    0,    0,  245,    0,  246,
  247,  248,    0,  249,
};
short yycheck[] = {                                       7,
  416,  359,   77,    7,   44,   44,   82,   34,  266,  253,
  266,  266,   95,  266,   87,  167,    7,  187,  256,  272,
  266,  168,  515,  269,  100,  271,  109,  110,  256,  266,
  258,  266,  266,  532,  272,  314,   44,   77,  292,  305,
  266,  292,  291,  195,  271,  289,  266,  405,  268,   45,
  123,  268,  184,   44,   50,  388,  266,  292,   66,   67,
  266,   69,   70,  266,  140,  314,  292,  143,  401,   77,
   66,   67,   68,   69,   70,   71,   72,   73,   74,  292,
  338,  337,  338,  268,   44,  266,   77,   95,  386,  266,
  336,  337,  338,  292,  392,  103,  589,  353,  291,  292,
  337,  109,  110,  268,  314,  315,  316,  353,  314,  315,
   84,  338,  292,  245,  393,  292,  248,   77,  201,  339,
  271,  314,  339,   33,   89,  338,  269,  393,   38,   39,
   40,   41,  338,  266,  337,  338,   46,  393,  393,  393,
  639,  387,  393,  401,  372,  401,  401,  393,  401,  269,
  353,  298,  401,  161,  339,  401,  337,  338,  166,  124,
  125,  126,  127,  401,  204,  161,  401,  401,   78,   79,
  586,  314,  353,  138,  387,  533,  184,  185,  330,  268,
  386,  189,  190,  191,  192,  193,  392,  338,  184,  605,
  393,  401,  266,  201,  393,  269,  204,  271,  401,  266,
  165,  433,  271,  268,  337,  338,  339,  387,  269,  388,
  206,  477,  393,  204,  393,  180,  393,  268,  338,  302,
  401,  266,  401,  298,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,  237,  238,  239,  204,  253,  266,  417,  418,  245,
  420,  421,  248,  249,  250,  251,  332,  265,  331,  391,
  526,  265,  336,  337,  338,  531,  498,  263,  401,  338,
  337,  279,  266,  291,  339,   97,  272,  338,  596,  353,
  266,  289,  271,  279,  291,  269,  353,  197,  198,  199,
  292,  269,  202,  271,  302,  338,  314,  338,  266,  395,
  269,  269,  329,   34,  548,  268,  387,  314,  269,  305,
  271,  133,  314,  387,  632,  315,  316,  337,  338,  393,
  328,  286,  296,  292,  393,  314,  393,  401,  291,  292,
  314,  292,  338,  353,  401,  314,  376,  316,  378,  379,
  380,  380,  489,  337,  387,  255,  387,  314,  315,  338,
  497,  314,  387,  388,  394,  502,  314,  315,  316,  353,
  338,  314,  315,  316,   95,  448,  449,  314,  376,  316,
  378,  379,  380,  393,  293,  619,  295,  296,  109,  110,
  314,  401,  316,  311,  312,  376,  394,  378,  379,  380,
  473,  635,  292,  292,  293,  391,  295,  296,  545,  393,
  299,  645,  367,  394,  393,  299,  269,  401,  271,  311,
  312,  407,  271,  306,  658,  392,  376,  425,  378,  379,
  380,  387,  388,  386,  387,  388,  482,  314,  484,  392,
  393,  314,  291,  292,  394,  314,  518,  519,  401,  266,
  448,  449,  469,  590,  440,  592,  593,  443,  319,  320,
  321,  322,  323,  388,  185,  314,  315,  338,  189,  190,
  191,  192,  193,  428,  611,  473,  541,  507,  615,  465,
  201,  393,  512,  513,  501,  471,  516,  516,  393,  338,
  627,  477,  629,  273,  274,  275,  276,  401,  395,  266,
  637,    0,  466,  333,  314,  460,  392,  462,  463,  507,
  339,  314,  314,  511,  512,  513,  514,  511,  516,  401,
  514,  314,  266,  478,  522,  338,  507,  269,  522,  269,
  269,  512,  513,  392,  392,  516,  392,  392,  387,  388,
  526,  392,  266,  395,  393,  531,  532,  387,  534,  314,
  548,  392,  401,  268,  393,  392,  338,  507,  392,  624,
  625,  269,  512,  513,  594,  387,  516,  338,  523,  387,
  393,  557,  393,  314,  560,  539,  562,  314,  542,  387,
  387,  302,  393,  269,  292,  293,  550,  295,  296,  553,
  554,  299,  266,  269,  558,  266,  594,  561,  584,  563,
  598,  393,  303,  401,  598,  401,  604,  328,  329,  266,
  604,  369,  269,  594,  271,  393,  292,  293,  267,  295,
  296,  619,  268,  299,  393,  393,  269,  591,  400,  393,
  339,  314,  271,  266,  338,  311,  312,  635,  338,  266,
  401,  392,  266,    0,  594,  393,  392,  645,  612,  266,
  393,  266,  339,  639,  373,  374,  375,  393,  622,  378,
  658,  393,  381,  382,  393,  338,  338,  386,  338,  388,
  389,  390,  392,  392,  638,  630,  266,  641,  314,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  659,  353,  268,  268,  268,
  268,  314,  269,  352,  425,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  271,  373,  374,  375,  448,  449,  378,
  387,  269,  381,  382,  339,  393,  393,  386,  393,  388,
  389,  390,  393,  392,  401,  399,  338,  269,  469,  269,
  353,  266,  473,  387,  353,  353,  314,  256,  269,  314,
  353,  306,  261,  262,  263,  306,  292,  266,  267,  268,
  269,  270,  299,  272,  273,  274,  275,  276,  277,  278,
  501,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,    0,  401,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  292,  387,  378,  334,  335,  381,  382,  401,
  387,  339,  386,  393,  388,  389,  390,  266,  392,  266,
  393,  314,  314,  269,  269,  269,  355,  269,  387,  358,
  269,  353,  166,  501,  274,  414,  597,  633,  184,  368,
  369,  448,  607,  449,  373,  496,  473,  566,  415,  378,
  263,  380,  381,  382,  513,  267,  425,  386,  272,  388,
  443,   15,  517,  392,  534,  536,  531,  396,  397,  256,
  399,  273,  401,   -1,  261,  262,  263,   -1,   -1,  266,
  267,  268,  269,  270,   -1,  272,  273,  274,  275,  276,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
   -1,   -1,  299,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   -1,   -1,   -1,  334,  335,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
   -1,  373,  374,  375,   -1,   -1,  378,   -1,  355,  381,
  382,  358,   -1,   -1,  386,   -1,  388,  389,  390,   -1,
  392,  368,  369,   -1,   -1,   -1,  373,   -1,   -1,   -1,
   -1,  378,   -1,  380,  381,  382,   -1,   -1,   -1,  386,
   -1,  388,   -1,   -1,   -1,  392,  267,   -1,   -1,  396,
  397,   -1,   -1,  400,  401,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  256,   -1,   -1,   -1,   -1,  261,
  262,  263,   -1,   -1,  266,  267,  268,   -1,  270,   -1,
  272,  273,  274,  275,  276,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,   -1,   -1,  299,  300,  301,
  302,  303,  304,  305,  306,  307,  308,  309,  310,   -1,
   -1,  313,  314,  315,  316,  317,  318,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,   -1,
   -1,   -1,  334,  335,  365,  366,  367,  368,  369,  370,
  371,   -1,  373,  374,  375,   -1,   -1,  378,   -1,   -1,
  381,  382,   -1,  355,   -1,  386,  358,  388,  389,  390,
   -1,  392,   -1,   -1,   -1,   -1,  368,  369,   -1,   -1,
   -1,  373,   -1,   -1,   -1,   -1,  378,   -1,  380,  381,
  382,  261,  262,  263,  386,   -1,  388,   -1,  267,   -1,
  392,   -1,   -1,   -1,  396,  397,   -1,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,   -1,  293,   -1,  295,  296,   -1,   -1,  299,
   -1,   -1,   -1,   -1,   -1,  267,  261,  262,  263,   -1,
   -1,   -1,   -1,   -1,  314,  315,  316,   -1,   -1,   -1,
   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  355,   -1,   -1,  358,  314,
  315,  316,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  369,
  369,  370,  371,  373,  373,  374,  375,   -1,   -1,  378,
   -1,   -1,  381,  382,   -1,   -1,   -1,  386,   -1,  388,
  389,  390,  392,  392,   -1,   -1,   -1,   -1,   -1,   -1,
  355,  401,   -1,  358,   -1,  367,  368,  369,  370,  371,
   -1,  373,  374,  375,  369,   -1,  378,   -1,  373,  381,
  382,   -1,   -1,   -1,  386,   -1,  388,  389,  390,   -1,
  392,   -1,   -1,   -1,   -1,   -1,   -1,  392,  261,  262,
  263,   -1,   -1,  266,  267,  268,  401,  270,   -1,   -1,
  273,  274,  275,  276,  277,  278,   -1,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,   -1,   -1,  299,  300,  301,  302,
  303,  304,  305,  306,  307,  308,  309,  310,   -1,   -1,
  313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
  323,  324,  325,  326,  327,  328,  329,  330,   -1,   -1,
   -1,  334,  335,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  368,  369,   -1,   -1,   -1,
  373,   -1,   -1,   -1,   -1,  378,   -1,  380,  381,  382,
   -1,   -1,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,
  261,  262,  263,  396,  397,  266,  267,  268,   -1,  270,
   -1,   -1,  273,  274,  275,  276,  277,  278,   -1,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,   -1,   -1,  294,   -1,   -1,   -1,   -1,   -1,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
   -1,   -1,  313,  314,  315,  316,  317,  318,  319,  320,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
   -1,   -1,   -1,  334,  335,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  368,  369,   -1,
   -1,   -1,  373,   -1,   -1,   -1,   -1,  378,   -1,  380,
  381,  382,   -1,   -1,   -1,  386,   -1,  388,   -1,   -1,
   -1,  392,  261,  262,  263,  396,  397,  266,  267,  268,
   -1,  270,   -1,   -1,  273,  274,  275,  276,  277,  278,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,   -1,   -1,  294,   -1,   -1,   -1,   -1,
   -1,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,   -1,   -1,  313,  314,  315,  316,   -1,   -1,
  319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,   -1,   -1,   -1,  334,  335,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  355,   -1,   -1,  358,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  368,
  369,   -1,   -1,   -1,  373,   -1,   -1,   -1,   -1,  378,
   -1,  380,  381,  382,   -1,   -1,   -1,  386,   -1,  388,
   -1,   -1,   -1,  392,  261,  262,  263,  396,  397,  266,
  267,  268,   -1,  270,   -1,   -1,  273,  274,  275,  276,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,   -1,   -1,  294,   -1,   -1,
   -1,   -1,   -1,  300,  301,  302,  303,  304,  305,  306,
  307,  308,  309,  310,   -1,   -1,  313,  314,  315,  316,
   -1,   -1,  319,  320,  321,  322,  323,  324,  325,  326,
  327,  328,  329,  330,   -1,   -1,   -1,  334,  335,  266,
  267,   -1,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  368,  369,   -1,   -1,   -1,  373,   -1,   -1,   -1,
   -1,  378,   -1,  380,  381,  382,   -1,   -1,   -1,  386,
   -1,  388,   -1,   -1,   -1,  392,   -1,   -1,   -1,  396,
  397,   -1,  266,  267,   -1,   -1,   -1,   -1,   -1,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,   -1,  373,  374,  375,   -1,
   -1,  378,   -1,   -1,  381,  382,   -1,   -1,   -1,  386,
  387,  388,  389,  390,   -1,  392,  393,  266,  267,   -1,
  269,   -1,  271,   -1,  401,  339,  340,  341,  342,  343,
  344,  345,  346,  347,  348,  349,  350,  351,  352,   -1,
  354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,  371,   -1,  373,
  374,  375,   -1,   -1,  378,   -1,   -1,  381,  382,   -1,
   -1,   -1,  386,   -1,  388,  389,  390,   -1,  392,   -1,
  267,   -1,  269,   -1,  271,   -1,   -1,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,   -1,  373,  374,  375,   -1,   -1,  378,
   -1,   -1,  381,  382,   -1,   -1,   -1,  386,  387,  388,
  389,  390,   -1,  392,  393,  266,  267,   -1,  269,  336,
  271,  338,  401,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,   -1,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,   -1,  373,  374,  375,   -1,
   -1,  378,   -1,   -1,  381,  382,   -1,   -1,   -1,  386,
   -1,  388,  389,  390,   -1,  392,   -1,   -1,   -1,   -1,
  267,   -1,   -1,   -1,  271,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,   -1,  373,  374,  375,   -1,   -1,  378,   -1,   -1,
  381,  382,   -1,   -1,   -1,  386,  387,  388,  389,  390,
   -1,  392,  393,  266,  267,   -1,  269,   -1,  271,   -1,
  401,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,   -1,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,   -1,  373,  374,  375,   -1,
   -1,  378,   -1,   -1,  381,  382,   -1,   -1,   -1,  386,
   -1,  388,  389,  390,   -1,  392,   -1,   -1,  267,   -1,
   -1,   -1,   -1,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,   -1,
  373,  374,  375,   -1,   -1,  378,   -1,   -1,  381,  382,
   -1,   -1,   -1,  386,  387,  388,  389,  390,   -1,  392,
  393,  266,  267,   -1,  269,   -1,  271,   -1,  401,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,   -1,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,   -1,  373,  374,  375,   -1,   -1,  378,
  267,   -1,  381,  382,   -1,   -1,   -1,  386,   -1,  388,
  389,  390,   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,   -1,  373,  374,
  375,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,   -1,  373,  374,  375,  267,
   -1,  378,   -1,   -1,  381,  382,   -1,   -1,   -1,  386,
   -1,  388,  389,  390,   -1,  392,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,   -1,  373,  374,
  375,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,   -1,  373,  374,  375,  267,   -1,
  378,   -1,   -1,  381,  382,   -1,   -1,   -1,  386,   -1,
  388,  389,  390,   -1,  392,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,   -1,  373,  374,
  375,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,   -1,  373,  374,  375,  267,   -1,  378,
   -1,   -1,  381,  382,   -1,   -1,   -1,  386,   -1,  388,
  389,  390,   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,   -1,  373,  374,
  375,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,   -1,  373,  374,  375,  267,   -1,  378,   -1,
   -1,  381,  382,   -1,   -1,   -1,  386,   -1,  388,  389,
  390,   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,   -1,  373,  374,
  375,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,   -1,  373,  374,  375,   -1,   -1,  378,   -1,   -1,
  381,  382,   -1,   -1,   -1,  386,   -1,  388,  389,  390,
   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,   -1,  373,  374,
  375,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,   -1,  373,  374,
  375,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,   -1,  373,  374,
  375,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,   -1,  373,  374,
  375,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,   -1,  373,  374,
  375,  266,  267,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,  371,  266,  267,   -1,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  266,  267,   -1,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,   -1,
   -1,   -1,   -1,   -1,  393,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,  266,
  267,   -1,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,
  393,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,  266,  267,   -1,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  266,   -1,   -1,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  387,   -1,   -1,   -1,
   -1,   -1,  393,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  266,   -1,   -1,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  266,   -1,   -1,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  261,  262,  263,   -1,  387,   -1,   -1,   -1,   -1,
   -1,  393,   -1,   -1,   -1,   -1,   -1,  277,  278,  401,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  315,  316,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  266,   -1,
   -1,  269,   -1,  271,   -1,  355,   -1,   -1,  358,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,  369,
   -1,   -1,   -1,  373,  393,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  392,  393,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  266,
   -1,   -1,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,
   -1,   -1,   -1,   -1,   -1,  393,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  401,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  266,   -1,
   -1,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  266,   -1,   -1,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,
   -1,   -1,   -1,   -1,   -1,  393,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  401,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  266,   -1,   -1,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,   -1,
   -1,   -1,   -1,   -1,  393,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  401,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  266,   -1,   -1,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,   -1,   -1,
   -1,  266,   -1,  393,  269,   -1,  271,   -1,   -1,   -1,
   -1,  401,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
   -1,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,  360,  387,   -1,  266,   -1,
   -1,  269,  393,  271,   -1,   -1,   -1,   -1,   -1,   -1,
  401,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  266,  387,   -1,  269,   -1,  271,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  266,   -1,   -1,  269,   -1,  271,  387,
   -1,   -1,   -1,   -1,   -1,  393,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  401,  266,   -1,   -1,  269,   -1,  271,
   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,  393,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  401,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,  355,  266,   -1,   -1,  269,   -1,  271,
   -1,   -1,   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,
  393,   -1,   -1,   -1,  266,   -1,   -1,  269,  401,  271,
   -1,   -1,   -1,   -1,   -1,  387,   -1,   -1,   -1,   -1,
   -1,  393,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  401,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
  352,  353,  354,   -1,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
   -1,  353,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  387,   -1,   -1,   -1,   -1,
   -1,  393,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  401,
   -1,  261,  262,  263,   -1,  387,   -1,  267,  268,   -1,
  270,  393,   -1,  273,  274,  275,  276,  277,  278,  401,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  300,  301,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  310,   -1,   -1,   -1,  314,  315,  316,   -1,   -1,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,   -1,   -1,   -1,  334,  335,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  368,  369,
   -1,   -1,   -1,  373,   -1,   -1,   -1,   -1,  378,   -1,
  380,  381,  382,   -1,   -1,   -1,  386,   -1,  388,  261,
  262,  263,  392,   -1,   -1,  267,   -1,   -1,  270,   -1,
   -1,  273,  274,  275,  276,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  300,  301,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,   -1,
   -1,   -1,  314,  315,  316,   -1,   -1,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,   -1,
   -1,   -1,  334,  335,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  368,  369,   -1,   -1,
   -1,  373,   -1,   -1,   -1,   -1,  378,   -1,  380,  381,
  382,   -1,   -1,   -1,  386,   -1,  388,  261,  262,  263,
  392,   -1,   -1,  267,  268,  269,  270,   -1,   -1,   -1,
   -1,   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  310,   -1,   -1,   -1,
  314,  315,  316,   -1,   -1,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,   -1,   -1,   -1,
  334,  335,  336,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  368,  369,   -1,   -1,   -1,  373,
   -1,   -1,   -1,   -1,  378,   -1,  380,  381,  382,   -1,
   -1,   -1,  386,   -1,  388,  261,  262,  263,  392,   -1,
   -1,  267,   -1,  269,  270,   -1,   -1,   -1,   -1,   -1,
   -1,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  310,   -1,   -1,   -1,  314,  315,
  316,   -1,   -1,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,   -1,   -1,   -1,  334,  335,
  336,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,
   -1,   -1,  358,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  368,  369,   -1,   -1,   -1,  373,   -1,   -1,
   -1,   -1,  378,   -1,  380,  381,  382,   -1,   -1,   -1,
  386,   -1,  388,  261,  262,  263,  392,   -1,   -1,  267,
  268,  269,  270,   -1,   -1,   -1,   -1,   -1,   -1,  277,
  278,   -1,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  310,   -1,   -1,   -1,  314,  315,  316,   -1,
   -1,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,   -1,   -1,   -1,  334,  335,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,   -1,   -1,
  358,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  368,  369,   -1,   -1,   -1,  373,   -1,   -1,   -1,   -1,
  378,   -1,  380,  381,  382,   -1,   -1,   -1,  386,   -1,
  388,  261,  262,  263,  392,   -1,   -1,  267,   -1,   -1,
  270,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  310,   -1,   -1,   -1,  314,  315,  316,   -1,   -1,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,   -1,   -1,   -1,  334,  335,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  368,  369,
   -1,   -1,   -1,  373,   -1,   -1,   -1,   -1,  378,   -1,
  380,  381,  382,   -1,   -1,   -1,  386,  387,  388,  261,
  262,  263,  392,   -1,   -1,  267,   -1,   -1,  270,  271,
   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  310,   -1,
   -1,   -1,  314,  315,  316,   -1,   -1,  319,  320,  321,
  322,  323,  324,  325,  326,  327,  328,  329,  330,   -1,
   -1,   -1,  334,  335,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  368,  369,   -1,   -1,
   -1,  373,   -1,   -1,   -1,   -1,  378,   -1,  380,  381,
  382,   -1,   -1,   -1,  386,   -1,  388,  261,  262,  263,
  392,   -1,   -1,  267,  268,   -1,  270,   -1,   -1,   -1,
   -1,   -1,   -1,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  310,   -1,   -1,   -1,
  314,  315,  316,   -1,   -1,  319,  320,  321,  322,  323,
  324,  325,  326,  327,  328,  329,  330,   -1,   -1,   -1,
  334,  335,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  368,  369,   -1,   -1,   -1,  373,
   -1,   -1,   -1,   -1,  378,   -1,  380,  381,  382,   -1,
   -1,   -1,  386,   -1,  388,  261,  262,  263,  392,   -1,
   -1,  267,   -1,   -1,  270,   -1,   -1,   -1,   -1,   -1,
   -1,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  310,   -1,   -1,   -1,  314,  315,
  316,   -1,   -1,  319,  320,  321,  322,  323,  324,  325,
  326,  327,  328,  329,  330,   -1,   -1,   -1,  334,  335,
  336,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,
   -1,   -1,  358,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  368,  369,   -1,   -1,   -1,  373,   -1,   -1,
   -1,   -1,  378,   -1,  380,  381,  382,   -1,   -1,   -1,
  386,   -1,  388,  261,  262,  263,  392,   -1,   -1,  267,
  268,   -1,  270,   -1,   -1,   -1,   -1,   -1,   -1,  277,
  278,   -1,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  310,   -1,   -1,   -1,  314,  315,  316,   -1,
   -1,  319,  320,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,   -1,   -1,   -1,  334,  335,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,   -1,   -1,
  358,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  368,  369,   -1,   -1,   -1,  373,   -1,   -1,   -1,   -1,
  378,   -1,  380,  381,  382,   -1,   -1,   -1,  386,   -1,
  388,  261,  262,  263,  392,   -1,   -1,  267,   -1,   -1,
  270,   -1,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  310,   -1,   -1,   -1,  314,  315,  316,   -1,   -1,  319,
  320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,   -1,   -1,   -1,  334,  335,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  368,  369,
   -1,   -1,   -1,  373,  261,  262,  263,   -1,  378,   -1,
  380,  381,  382,   -1,   -1,   -1,  386,   -1,  388,   -1,
  277,  278,  392,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  261,  262,  263,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,  315,  316,
   -1,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  267,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  355,  315,
  316,  358,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  369,   -1,   -1,   -1,  373,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,  355,
   -1,   -1,  358,   -1,  267,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  369,   -1,   -1,   -1,  373,   -1,   -1,
   -1,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  347,  348,  349,  350,  351,  352,  392,  354,  355,  356,
  357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,  371,   -1,  373,  374,  375,  267,
   -1,  378,   -1,   -1,  381,  382,   -1,   -1,   -1,  386,
   -1,  388,  389,  390,   -1,  392,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
  353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,   -1,
  373,  374,  375,   -1,  267,  378,   -1,   -1,  381,  382,
   -1,   -1,   -1,  386,   -1,  388,  389,  390,  336,  392,
   -1,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,   -1,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,   -1,  373,  374,  375,  267,   -1,
  378,   -1,   -1,  381,  382,   -1,   -1,   -1,  386,   -1,
  388,  389,  390,   -1,  392,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
   -1,  354,  355,  356,  357,  358,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,  371,   -1,
  373,  374,  375,   -1,   -1,  378,   -1,   -1,  381,  382,
   -1,   -1,   -1,  386,   -1,  388,  389,  390,   -1,  392,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,   -1,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,   -1,  373,  374,  375,   -1,   -1,  378,
   -1,   -1,  381,  382,   -1,   -1,   -1,  386,   -1,  388,
  389,  390,   -1,  392,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 401
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"opt_typename","VAR","EXPR",
"ARRAY","STRUCT","UNION","ENUM","COMP","HASH","SEMI","MOD","OC","CC","DOLLAR",
"DOTDOTDOT","ENDFILE","GLOBAL","AUTO","STATIC","CONST","POLY","INTEGER",
"NATURAL","RATIONAL","REAL","STRING","FOREIGN","FILET","MUTEX","SEMAPHORE",
"CONTINUATION","THREAD","VOID","BOOL","FUNCTION","FUNC","EXCEPTION","RAISE",
"TYPEDEF","IMPORT","NEW","ANONINIT","NAMESPACE","PUBLIC","PROTECTED","EXTEND",
"WHILE","DO","FOR","SWITCH","BREAK","CONTINUE","RETURNTOK","FORK","CASE",
"DEFAULT","TWIXT","NAME","TYPENAME","NAMESPACENAME","COMMAND","NAMECOMMAND",
"TEN_NUM","OCTAL0_NUM","OCTAL_NUM","BINARY_NUM","HEX_NUM","TEN_FLOAT",
"OCTAL0_FLOAT","OCTAL_FLOAT","BINARY_FLOAT","HEX_FLOAT","CHAR_CONST",
"STRING_CONST","POLY_CONST","THREAD_CONST","COMMENT_CONST","VOIDVAL","BOOLVAL",
"DARROW","POUND","COMMA","ASSIGN","ASSIGNPLUS","ASSIGNMINUS","ASSIGNTIMES",
"ASSIGNDIVIDE","ASSIGNDIV","ASSIGNMOD","ASSIGNPOW","ASSIGNSHIFTL",
"ASSIGNSHIFTR","ASSIGNLXOR","ASSIGNLAND","ASSIGNLOR","QUEST","COLON","OR","AND",
"LOR","LXOR","LAND","EQ","NE","LT","GT","LE","GE","SHIFTL","SHIFTR","PLUS",
"MINUS","TIMES","DIVIDE","DIV","POW","STARSTAR","POW2","POW3","UNIONCAST",
"UMINUS","BANG","FACT","LNOT","INC","DEC","STAR","AMPER","THREADID","OS","CS",
"DOT","ARROW","STAROS","CALL","OP","CP","POINTER","COLONCOLON","IF","TRY",
"NONL","ELSE","CATCH","NL",
};
char *yyrule[] = {
"$accept : lines",
"lines : lines pcommand",
"lines :",
"pcommand : command",
"pcommand : error reset eend",
"eend : NL",
"eend : SEMI",
"eend : ENDFILE",
"ignorenl :",
"attendnl :",
"reset :",
"not_command :",
"opt_nl : NL",
"opt_nl :",
"opt_semi : SEMI",
"opt_semi :",
"opt_comma : COMMA",
"opt_comma :",
"command : not_command expr reset NL",
"command : not_command expr POUND expr reset NL",
"command : not_command statement reset opt_nl",
"command : not_command COMMAND opt_exprs reset opt_semi NL",
"command : not_command NAMECOMMAND opt_rawnames reset opt_semi NL",
"command : NL",
"command : ENDFILE",
"opt_rawnames : rawnames",
"opt_rawnames :",
"rawnames : rawname COMMA rawnames",
"rawnames : rawname",
"rawname : rawnamespace rawatom",
"rawatom : NAME",
"rawatom : NAMESPACENAME",
"rawatom : TYPENAME",
"rawnamespace : rawnamespace rawatom COLONCOLON",
"rawnamespace :",
"fulltype : namespace TYPENAME",
"fulltype : TYPENAME",
"fullname : namespace namespacename",
"fullname : namespacename",
"fullnames : fullname",
"fullnames : fullname COMMA fullnames",
"namespace : namespace NAMESPACENAME COLONCOLON",
"namespace : NAMESPACENAME COLONCOLON",
"namespacename : NAME",
"namespacename : NAMESPACENAME",
"namespace_start :",
"namespace_end :",
"block : block_start statements block_end",
"block_start : OC namespace_start",
"block_end : namespace_end CC",
"statements : statement statements",
"statements :",
"if_statement : IF ignorenl namespace_start OP expr CP statement",
"if_statement : IF ignorenl namespace_start OP expr CP statement ELSE statement",
"statement : simple_statement",
"statement : block",
"simple_statement : if_statement namespace_end attendnl",
"simple_statement : WHILE ignorenl namespace_start OP expr CP statement namespace_end attendnl",
"simple_statement : DO ignorenl namespace_start statement WHILE OP expr CP namespace_end attendnl",
"simple_statement : FOR ignorenl namespace_start OP for_exprs CP statement namespace_end attendnl",
"simple_statement : SWITCH ignorenl namespace_start OP expr CP case_block namespace_end attendnl",
"simple_statement : union_or_enum SWITCH ignorenl namespace_start OP expr CP union_case_block namespace_end attendnl",
"simple_statement : BREAK SEMI",
"simple_statement : CONTINUE SEMI",
"simple_statement : RETURNTOK opt_expr SEMI",
"simple_statement : expr SEMI",
"simple_statement : SEMI",
"simple_statement : func_decl doc_string opt_func_body namespace_end",
"simple_statement : opt_publish EXCEPTION ignorenl NAME namespace_start opt_argdecls namespace_end doc_string SEMI attendnl",
"simple_statement : RAISE fullname OP opt_exprs CP SEMI",
"simple_statement : opt_publish TYPEDEF ignorenl typenames SEMI attendnl",
"simple_statement : opt_publish TYPEDEF ignorenl type typenames SEMI attendnl",
"$$1 :",
"simple_statement : publish_extend NAMESPACE ignorenl namespacename $$1 OC statements CC attendnl",
"simple_statement : opt_publish IMPORT ignorenl fullnames SEMI attendnl",
"simple_statement : try_statement attendnl",
"simple_statement : TWIXT ignorenl namespace_start OP opt_expr SEMI opt_expr CP statement namespace_end attendnl",
"for_exprs : opt_expr SEMI for_exprs",
"for_exprs : opt_expr",
"try_body_statement : simple_statement",
"try_body_statement : OC statements CC",
"try_statement : TRY ignorenl try_body_statement catches",
"catches : catches catch",
"catches :",
"catch : CATCH fullname namespace_start args doc_string block namespace_end",
"opt_func_body : func_body",
"opt_func_body : SEMI",
"$$2 :",
"func_body : $$2 block_or_expr",
"block_or_expr : block",
"block_or_expr : attendnl ASSIGN simpleexpr SEMI",
"union_or_enum : UNION",
"union_or_enum : ENUM",
"see_comment :",
"doc_string : see_comment opt_comment",
"opt_comment : COMMENT_CONST",
"opt_comment :",
"case_block : block_start cases block_end",
"cases : case cases",
"cases :",
"case : CASE expr COLON statements",
"case : DEFAULT COLON statements",
"union_case_block : block_start union_cases block_end",
"union_cases : union_case union_cases",
"union_cases :",
"union_case : CASE namespace_start NAME opt_name COLON statements namespace_end",
"union_case : DEFAULT COLON statements",
"opt_name : NAME",
"opt_name :",
"atoms : NAME COMMA atoms",
"atoms : NAME",
"typenames : typename COMMA typenames",
"typenames : typename",
"typename : TYPENAME",
"typename : NAME",
"initnames : name opt_init next_decl initnames",
"initnames : name opt_init",
"name : NAME",
"next_decl : COMMA",
"func_decl : func_name namespace_start opt_argdefines CP",
"func_name : decl NAME OP",
"func_name : decl FUNCTION NAME OP",
"func_name : FUNCTION ignorenl NAME OP",
"opt_init : ASSIGN simpleexpr",
"opt_init : ASSIGN init",
"opt_init :",
"decl : publish opt_class opt_type opt_nl",
"decl : class opt_type opt_nl",
"decl : type opt_nl",
"subscripts : opt_argdecls subscripts",
"subscripts : OS opt_stars CS subscripts",
"subscripts : OS dotdotdots CS subscripts",
"subscripts : OS dims CS subscripts",
"subscripts : OS type CS subscripts",
"subscripts :",
"type : subtype subscripts",
"type : TIMES type",
"type : STARSTAR type",
"type : AND type",
"type : LAND type",
"subtype : basetype",
"subtype : STRUCT OC struct_members CC",
"subtype : UNION OC union_members CC",
"subtype : ENUM OC atoms CC",
"subtype : OP type CP",
"subtype : fulltype",
"opt_type : type",
"opt_type :",
"basetype : POLY",
"basetype : INTEGER",
"basetype : RATIONAL",
"basetype : REAL",
"basetype : STRING",
"basetype : FILET",
"basetype : MUTEX",
"basetype : SEMAPHORE",
"basetype : CONTINUATION",
"basetype : THREAD",
"basetype : VOID",
"basetype : BOOL",
"basetype : FOREIGN",
"opt_stars : stars",
"opt_stars :",
"stars : stars COMMA TIMES",
"stars : TIMES",
"dotdotdots : dotdotdots COMMA DOTDOTDOT",
"dotdotdots : DOTDOTDOT",
"dims : simpleexpr COMMA dims",
"dims : simpleexpr",
"struct_members : opt_type atoms SEMI struct_members",
"struct_members :",
"union_members : opt_type atoms SEMI union_members",
"union_members :",
"opt_class : class",
"opt_class :",
"class : GLOBAL",
"class : AUTO",
"class : STATIC",
"class : CONST",
"opt_publish : publish",
"opt_publish :",
"publish : PUBLIC",
"publish : PROTECTED",
"publish_extend : opt_publish",
"publish_extend : EXTEND",
"opt_argdecls : OP argdecls CP",
"opt_argdecls : OP CP",
"argdecls : argdecl COMMA argdecls",
"argdecls : argdecl opt_dotdotdot",
"argdecl : type NAME",
"argdecl : type",
"args : OP opt_argdefines CP",
"opt_argdefines : ignorenl argdefines",
"opt_argdefines : ignorenl",
"argdefines : argdefine COMMA argdefines",
"argdefines : argdefine opt_dotdotdot",
"argdefine : opt_type NAME",
"argdefine : type",
"opt_dotdotdot : DOTDOTDOT",
"opt_dotdotdot :",
"opt_expr : expr",
"opt_expr :",
"expr : comma_expr",
"expr : decl initnames",
"comma_expr : simpleexpr",
"comma_expr : comma_expr COMMA simpleexpr",
"opt_exprs : exprs",
"opt_exprs :",
"exprs : simpleexpr COMMA exprs",
"exprs : simpleexpr",
"opt_actuals : actuals",
"opt_actuals :",
"actuals : simpleexpr COMMA actuals",
"actuals : simpleexpr opt_dotdotdot",
"func_right : attendnl ASSIGN simpleexpr",
"$$3 :",
"func_right : $$3 block",
"simpleexpr : simpleexpr assignop simpleexpr",
"simpleexpr : opt_type FUNC namespace_start args doc_string func_right namespace_end",
"simpleexpr : MOD integer",
"simpleexpr : TIMES simpleexpr",
"simpleexpr : STARSTAR simpleexpr",
"simpleexpr : LAND simpleexpr",
"simpleexpr : AND simpleexpr",
"simpleexpr : MINUS simpleexpr",
"simpleexpr : LNOT simpleexpr",
"simpleexpr : BANG simpleexpr",
"simpleexpr : simpleexpr BANG",
"simpleexpr : INC simpleexpr",
"simpleexpr : simpleexpr INC",
"simpleexpr : DEC simpleexpr",
"simpleexpr : simpleexpr DEC",
"simpleexpr : FORK simpleexpr",
"simpleexpr : simpleexpr PLUS simpleexpr",
"simpleexpr : simpleexpr MINUS simpleexpr",
"simpleexpr : simpleexpr TIMES simpleexpr",
"simpleexpr : simpleexpr DIVIDE simpleexpr",
"simpleexpr : simpleexpr DIV simpleexpr",
"simpleexpr : simpleexpr MOD simpleexpr",
"simpleexpr : simpleexpr STARSTAR simpleexpr",
"simpleexpr : simpleexpr POW2",
"simpleexpr : simpleexpr POW3",
"simpleexpr : simpleexpr SHIFTL simpleexpr",
"simpleexpr : simpleexpr SHIFTR simpleexpr",
"simpleexpr : simpleexpr QUEST simpleexpr COLON simpleexpr",
"simpleexpr : simpleexpr LXOR simpleexpr",
"simpleexpr : simpleexpr LAND simpleexpr",
"simpleexpr : simpleexpr LOR simpleexpr",
"simpleexpr : simpleexpr AND simpleexpr",
"simpleexpr : simpleexpr OR simpleexpr",
"simpleexpr : simpleexpr EQ simpleexpr",
"simpleexpr : simpleexpr NE simpleexpr",
"simpleexpr : simpleexpr LT simpleexpr",
"simpleexpr : simpleexpr GT simpleexpr",
"simpleexpr : simpleexpr LE simpleexpr",
"simpleexpr : simpleexpr GE simpleexpr",
"simpleexpr : fullname",
"simpleexpr : TEN_NUM",
"simpleexpr : OCTAL_NUM",
"simpleexpr : OCTAL0_NUM",
"simpleexpr : BINARY_NUM",
"simpleexpr : HEX_NUM",
"simpleexpr : TEN_FLOAT",
"simpleexpr : OCTAL_FLOAT",
"simpleexpr : OCTAL0_FLOAT",
"simpleexpr : BINARY_FLOAT",
"simpleexpr : HEX_FLOAT",
"simpleexpr : CHAR_CONST",
"simpleexpr : STRING_CONST",
"simpleexpr : VOIDVAL",
"simpleexpr : BOOLVAL",
"simpleexpr : OS CS",
"simpleexpr : OP type CP namespace_start init namespace_end",
"simpleexpr : OP OS stars CS CP namespace_start arrayinit namespace_end",
"simpleexpr : OP OS dims CS CP namespace_start opt_arrayinit namespace_end",
"simpleexpr : OP OS type CS CP namespace_start opt_hashinit namespace_end",
"simpleexpr : type DOT NAME",
"simpleexpr : OP type DOT NAME CP simpleexpr",
"simpleexpr : DOLLAR opt_integer",
"simpleexpr : DOT",
"simpleexpr : OP expr CP",
"simpleexpr : OP block CP",
"simpleexpr : simpleexpr STAROS dims CS",
"simpleexpr : simpleexpr OS dims CS",
"simpleexpr : simpleexpr OP opt_actuals CP",
"simpleexpr : simpleexpr DOT NAME",
"simpleexpr : simpleexpr ARROW NAME",
"opt_integer : integer",
"opt_integer :",
"assignop : ASSIGNPLUS",
"assignop : ASSIGNMINUS",
"assignop : ASSIGNTIMES",
"assignop : ASSIGNDIVIDE",
"assignop : ASSIGNDIV",
"assignop : ASSIGNMOD",
"assignop : ASSIGNPOW",
"assignop : ASSIGNSHIFTL",
"assignop : ASSIGNSHIFTR",
"assignop : ASSIGNLXOR",
"assignop : ASSIGNLAND",
"assignop : ASSIGNLOR",
"assignop : ASSIGN",
"integer : TEN_NUM",
"integer : OCTAL_NUM",
"integer : OCTAL0_NUM",
"integer : BINARY_NUM",
"integer : HEX_NUM",
"opt_arrayinit : arrayinit",
"opt_arrayinit : OC CC",
"opt_arrayinit :",
"arrayinit : OC arrayelts opt_comma opt_dotdotdot CC",
"arrayinit : OC OS namespace_start compnames comparray CS comprehension namespace_end CC",
"comprehension : ASSIGN arrayelt",
"comprehension : block",
"compnames : compname COMMA compnames",
"compnames : compname",
"compname : NAME",
"comparray :",
"arrayelts : arrayelts COMMA arrayelt",
"arrayelts : arrayelt",
"arrayelt : simpleexpr",
"arrayelt : init",
"opt_hashinit : hashinit",
"opt_hashinit : OC CC",
"opt_hashinit :",
"hashinit : OC hashelts opt_comma CC",
"hashelts : hashelts COMMA hashelt",
"hashelts : hashelt",
"hashelt : simpleexpr DARROW hashvalue",
"hashelt : DARROW hashvalue",
"hashvalue : simpleexpr",
"hashvalue : init",
"structinit : OC structelts opt_comma CC",
"structelts : structelts COMMA structelt",
"structelts : structelt",
"structelt : NAME ASSIGN simpleexpr",
"structelt : NAME ASSIGN init",
"init : arrayinit",
"init : structinit",
"init : hashinit",
"init : OC CC",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 1604 "gram.y"

static void
DeclListMark (void *object)
{
    DeclListPtr	dl = object;

    MemReference (dl->next);
    MemReference (dl->init);
}

DataType DeclListType = { DeclListMark, 0, "DeclListType" };

DeclListPtr
NewDeclList (Atom name, ExprPtr init, DeclListPtr next)
{
    ENTER ();
    DeclListPtr	dl;

    dl = ALLOCATE (&DeclListType, sizeof (DeclList));
    dl->next = next;
    dl->name = name;
    dl->symbol = 0;
    dl->init = init;
    RETURN (dl);
}

static void
MemListMark (void *object)
{
    MemListPtr	ml = object;

    MemReference (ml->next);
    MemReference (ml->type);
    MemReference (ml->atoms);
}

DataType MemListType = { MemListMark, 0, "MemListType" };

MemListPtr
NewMemList (AtomListPtr atoms, Type *type, MemListPtr next)
{
    ENTER ();
    MemListPtr	ml;

    ml = ALLOCATE (&MemListType, sizeof (MemList));
    ml->next = next;
    ml->type = type;
    ml->atoms = atoms;
    RETURN (ml);
}


extern NamespacePtr	CurrentNamespace;
FramePtr	CurrentFrame;

Value
lookupVar (char *ns, char *n)
{
    ENTER ();
    Value	    v;
    SymbolPtr	    symbol;
    NamespacePtr    namespace;
    Bool	    search;

    search = True;
    namespace = CurrentNamespace;
    if (ns)
    {
	symbol = NamespaceFindName (CurrentNamespace, AtomId (ns), True);
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
    }
    if (namespace)
	symbol = NamespaceFindName (namespace, AtomId (n), search);
    else
	symbol = 0;
    if (symbol && symbol->symbol.class == class_global)
	v = BoxValue (symbol->global.value, 0);
    else
	v = Void;
    RETURN (v);
}

void
setVar (NamespacePtr namespace, char *n, Value v, Type *type)
{
    ENTER ();
    Atom	atom;
    SymbolPtr	symbol;

    atom = AtomId (n);
    symbol = NamespaceFindName (namespace, atom, True);
    if (!symbol)
	symbol = NamespaceAddName (namespace,
				   NewSymbolGlobal (atom, type),
				   publish_private);
    if (symbol->symbol.class == class_global)
	BoxValueSet (symbol->global.value, 0, v);
    EXIT ();
}

void
GetNamespace (NamespacePtr *scope, FramePtr *fp, CodePtr *cp)
{
    *scope = CurrentNamespace;
    *fp = CurrentFrame;
    if (CurrentFrame)
	*cp = CurrentFrame->function->func.code;
    else
	*cp = 0;
}

ExprPtr
BuildName (char *ns, char *n)
{
    ENTER ();
    SymbolPtr	    symbol, ns_symbol = 0;
    Atom	    atom, ns_atom = 0;
    Bool	    search = True;
    NamespacePtr    namespace = CurrentNamespace;
    ExprPtr	    e;
    Bool	    ns_privateFound = False;
    Bool	    privateFound = False;

    if (ns)
    {
	ns_atom = AtomId (ns);
	ns_symbol = NamespaceFindName (namespace, ns_atom, search);
	if (ns_symbol && ns_symbol->symbol.class == class_namespace)
	    namespace = ns_symbol->namespace.namespace;
	else
	{
	    if (!ns_symbol)
		ns_privateFound = NamespaceIsNamePrivate (namespace, ns_atom, search);
	    namespace = 0;
	}
	search = False;
    }
    atom = AtomId (n);
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    e = NewExprAtom (atom, symbol, privateFound);
    if (ns_atom)
	e = NewExprTree (COLONCOLON, NewExprAtom (ns_atom, ns_symbol, ns_privateFound), e);
    RETURN (e);
}

static Value
AtomString (Atom id)
{
    ENTER ();
    RETURN (NewStrString (AtomName (id)));
}

ExprPtr
BuildRawname (ExprPtr colonnames, Atom name)
{
    ENTER ();
    int     len;
    Value   array;
    ExprPtr e;

    len = 1;
    for (e = colonnames; e; e = e->tree.left)
	len++;
    array = NewArray (False, False, typePrim[rep_string], 1, &len);
    len--;
    ArrayValueSet (&array->array, len, AtomString (name));
    e = colonnames;
    while (--len >= 0)
    {
	ArrayValueSet (&array->array, len, AtomString (e->tree.right->atom.atom));
	e = e->tree.left;
    }
    e = NewExprConst (POLY_CONST, array);
    RETURN (e);
}

	    
ExprPtr
BuildFullname (ExprPtr left, Atom atom)
{
    ENTER ();
    NamespacePtr    namespace;
    SymbolPtr	    symbol;
    Bool	    search;
    ExprPtr	    nameExpr;
    Bool	    privateFound = False;

    if (left)
    {
	if (left->base.tag == COLONCOLON)
	    symbol = left->tree.right->atom.symbol;
	else
	    symbol = left->atom.symbol;
	if (symbol && symbol->symbol.class == class_namespace)
	    namespace = symbol->namespace.namespace;
	else
	    namespace = 0;
        search = False;
    }
    else
    {
	namespace = CurrentNamespace;
	search = True;
    }
    if (namespace)
    {
	symbol = NamespaceFindName (namespace, atom, search);
	if (!symbol)
	    privateFound = NamespaceIsNamePrivate (namespace, atom, search);
    }
    else
	symbol = 0;
    nameExpr = NewExprAtom (atom, symbol, privateFound);
    if (left)
	nameExpr = NewExprTree (COLONCOLON, left, nameExpr);
    RETURN (nameExpr);
}

ExprPtr
BuildCall (char *scope, char *name, int nargs, ...)
{
    ENTER ();
    va_list	    alist;
    ExprPtr	    args, *prev;
    ExprPtr	    f;
    ExprPtr	    e;

    va_start (alist, nargs);
    prev = &args;
    args = 0;
    while (nargs--)
    {
	*prev = NewExprTree (COMMA, va_arg (alist, ExprPtr), 0);
	prev = &(*prev)->tree.right;
    }
    va_end (alist);
    f = BuildName (scope, name);
    e = NewExprTree (OP, f, args);
#ifdef DEBUG
    printExpr (stdout, e, -1, 0);
    printf ("\n");
#endif
    RETURN (e);
}

/*
 * Walk for() loop arguments and normalize the list
 */
static Expr *
ParseCanonFor (Expr *expr)
{
    if (!expr || !expr->tree.right) {
        ParseError ("Too few exprs in for()\n");
        return 0;
    }
    if (!expr->tree.right->tree.right) {
        /* 2-argument for() */
        expr = NewExprTree(FOR, 0, expr);
    }
    if (expr->tree.right->tree.right->tree.right) {
        ParseError ("Too many exprs in for()\n");
        return 0;
    }
    return expr;
}

/*
 * Walk a type structure and resolve any type names
 */
static CanonTypeResult
ParseCanonType (TypePtr type, Bool forwardAllowed)
{
    ArgType	    *arg;
    int		    n;
    CanonTypeResult ret = CanonTypeDefined, t;
    Bool	    anyResolved;
    
    if (!type)
    {
	ParseError ("Type missing inside compiler");
	return False;
    }
    switch (type->base.tag) {
    case type_prim:
	break;
    case type_name:
	if (!TypeNameType(type))
	{
	    if (!type->name.name)
	    {
		ExprPtr e;
		e = type->name.expr;
		if (e->base.tag == COLONCOLON)
		    e = e->tree.right;
		type->name.name = e->atom.symbol;
		if (!type->name.name)
		{
		    ParseError ("No typedef \"%A\" in namespace",
				e->atom.atom);
		    ret = CanonTypeUndefined;
		    break;
		}
	    }
	    if (type->name.name->symbol.class != class_typedef)
	    {
		ParseError ("Symbol \"%A\" not a typedef", 
			    type->name.name->symbol.name);
		ret = CanonTypeUndefined;
	    }
	    else if (!TypeNameType(type))
	    {
		if (!forwardAllowed)
		    ParseError ("Typedef \"%A\" not defined yet", 
				type->name.name->symbol.name);
		ret = CanonTypeForward;
	    }
	    else
	    {
		ret = ParseCanonType (TypeNameType(type), forwardAllowed);
	    }
	}
	break;
    case type_ref:
	ret = ParseCanonType (type->ref.ref, True);
	if (ret == CanonTypeForward)
	    ret = CanonTypeDefined;
	break;
    case type_func:
	if (type->func.ret)
	    ret = ParseCanonType (type->func.ret, forwardAllowed);
	for (arg = type->func.args; arg; arg = arg->next)
	{
	    t = ParseCanonType (arg->type, forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_array:
	ret = ParseCanonType (type->array.type, forwardAllowed);
	break;
    case type_hash:
	ret = ParseCanonType (type->hash.type, forwardAllowed);
	t = ParseCanonType (type->hash.keyType, forwardAllowed);
	if (t < ret)
	    ret = t;
	break;
    case type_struct:
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], forwardAllowed);
	    if (t < ret)
		ret = t;
	}
	break;
    case type_union:
	anyResolved = False;
	for (n = 0; n < type->structs.structs->nelements; n++)
	{
	    StructType   *st = type->structs.structs;

	    t = ParseCanonType (BoxTypesElements(st->types)[n], True);
	    if (t < ret)
		ret = t;
	    if (t == CanonTypeDefined)
		anyResolved = True;
	}
	if (ret == CanonTypeForward)
	{
	    if (anyResolved)
		ret = CanonTypeDefined;
	    else if (!forwardAllowed)
		ParseError ("No member of '%T' defined yet", type);
	}
	break;
    case type_types:
	break;
    }
    return ret;
}

static SymbolPtr
ParseNewSymbol (Publish publish, Class class, Type *type, Atom name)
{
    ENTER ();
    SymbolPtr	s = 0;
    
    if (class == class_undef)
	class = funcDepth ? class_auto : class_global;

    if (class == class_namespace || 
	(class == class_typedef && type == 0) || 	
	ParseCanonType (type, False) == CanonTypeDefined)
    {
	switch (class) {
	case class_const:
	    s = NewSymbolConst (name, type);
	    break;
	case class_global:
	    s = NewSymbolGlobal (name, type);
	    break;
	case class_static:
	    s = NewSymbolStatic (name, type);
	    break;
	case class_arg:
	    s = NewSymbolArg (name, type);
	    break;
	case class_auto:
	    s = NewSymbolAuto (name, type);
	    break;
	case class_exception:
	    s = NewSymbolException (name, type, Void);
	    break;
	case class_typedef:
	    /*
	     * Special case for typedefs --
	     * allow forward declaration of untyped
	     * typedef names, then hook the
	     * new type to the old name
	     */
	    if (type)
	    {
		s = NamespaceFindName (CurrentNamespace, name, False);
		if (s && s->symbol.class == class_typedef && !s->symbol.type)
		{
		    s->symbol.type = type;
		    RETURN (s);
		}
	    }
	    s = NewSymbolType (name, type);
	    break;
	case class_namespace:
	    s = NewSymbolNamespace (name, NewNamespace (CurrentNamespace));
	    break;
	case class_undef:
	    break;
	}
	if (s)
	    NamespaceAddName (CurrentNamespace, s, publish);
    }
    RETURN (s);
}

int
yywrap (void)
{
    if (LexInteractive())
	printf ("\n");
    if (CurrentFrame)
    {
	do_Debug_done ();
	return 0;
    }
    return 1;
}

extern	char *yytext;

void
ParseError (char *fmt, ...)
{
    va_list	args;

    if (LexFileName ())
	FilePrintf (FileStderr, "%A:%d: ",
		    LexFileName (), LexFileLine ());
    va_start (args, fmt);
    FileVPrintf (FileStderr, fmt, args);
    FilePrintf (FileStderr, "\n");
    va_end (args);
}

void
yyerror (char *msg)
{
    ignorenl = 0;
    ParseError ("%s before %S", msg, yytext);
}
#line 2863 "gram.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 197 "gram.y"
{ yyerrok; }
break;
case 6:
#line 199 "gram.y"
{ yyerrok; }
break;
case 7:
#line 201 "gram.y"
{ yyerrok; }
break;
case 8:
#line 209 "gram.y"
{ ignorenl++; }
break;
case 9:
#line 212 "gram.y"
{ if (ignorenl > 0) ignorenl--; }
break;
case 10:
#line 215 "gram.y"
{ 
			ignorenl = 0; 
			LexNamespace = 0; 
			CurrentNamespace = TopNamespace; 
			funcDepth = 0; 
			notCommand = 0;
		    }
break;
case 11:
#line 232 "gram.y"
{ notCommand = 1; }
break;
case 18:
#line 247 "gram.y"
{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			
			e = BuildCall ("Command", "display",
				       1,NewExprTree (EXPR, yyvsp[-2].expr, 0));
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 19:
#line 263 "gram.y"
{
			ENTER ();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;

			e = BuildCall("Command", "display_base",
				      2, NewExprTree (EXPR, yyvsp[-4].expr, 0), yyvsp[-2].expr);
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileExpr (e, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 20:
#line 279 "gram.y"
{ 
			ENTER ();
			NamespacePtr    s;
			FramePtr	f;
			CodePtr		c;
			Value		t;
			
			GetNamespace (&s, &f, &c);
			t = NewThread (f, CompileStat (yyvsp[-2].expr, c));
			ThreadsRun (t, 0);
			EXIT ();
		    }
break;
case 21:
#line 292 "gram.y"
{
			ENTER();
			ExprPtr	e;
			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yyvsp[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yyvsp[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yyvsp[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 22:
#line 316 "gram.y"
{
			ENTER ();
			ExprPtr e;

			Value	t;
			NamespacePtr	s;
			FramePtr	f;
			CodePtr		c;
			CommandPtr	cmd;

			cmd = CommandFind (CurrentCommands, yyvsp[-4].atom);
			if (!cmd)
			    ParseError ("Undefined command \"%s\"", AtomName (yyvsp[-4].atom));
			else
			{
			    e = NewExprTree (OP, 
					     NewExprConst (POLY_CONST, cmd->func),
					     yyvsp[-3].expr);
			    GetNamespace (&s, &f, &c);
			    t = NewThread (f, CompileExpr (e, c));
			    ThreadsRun (t, 0);
			}
			EXIT ();
		    }
break;
case 26:
#line 345 "gram.y"
{ yyval.expr = 0; }
break;
case 27:
#line 348 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 28:
#line 350 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 29:
#line 353 "gram.y"
{ yyval.expr = BuildRawname (yyvsp[-1].expr, yyvsp[0].atom); }
break;
case 33:
#line 360 "gram.y"
{ yyval.expr = NewExprTree (COLONCOLON, yyvsp[-2].expr, NewExprAtom (yyvsp[-1].atom, 0, False)); }
break;
case 34:
#line 362 "gram.y"
{ yyval.expr = 0; }
break;
case 35:
#line 365 "gram.y"
{ 
			yyval.expr = BuildFullname (yyvsp[-1].expr, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 36:
#line 370 "gram.y"
{ 
			yyval.expr = BuildFullname (0, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 37:
#line 376 "gram.y"
{ 
			yyval.expr = BuildFullname (yyvsp[-1].expr, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 38:
#line 381 "gram.y"
{
			yyval.expr = BuildFullname (0, yyvsp[0].atom);
			LexNamespace = 0;
		    }
break;
case 39:
#line 387 "gram.y"
{
			yyval.expr = yyvsp[0].expr;
		    }
break;
case 40:
#line 391 "gram.y"
{
			yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr);
		    }
break;
case 41:
#line 396 "gram.y"
{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (yyvsp[-2].expr, yyvsp[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yyvsp[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yyvsp[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 42:
#line 419 "gram.y"
{ 
			ExprPtr	    e;
			SymbolPtr   symbol;

			e = BuildFullname (0, yyvsp[-1].atom);
			if (e->base.tag == COLONCOLON)
			    symbol = e->tree.right->atom.symbol;
			else
			    symbol = e->atom.symbol;
			if (!symbol)
			{
			    ParseError ("non-existant namespace \"%A\"", yyvsp[-1].atom);
			    YYERROR;
			}
			else if (symbol->symbol.class != class_namespace)
			{
			    ParseError ("%A is not a namespace", yyvsp[-1].atom);
			    YYERROR;
			}
			LexNamespace = symbol->namespace.namespace;
			yyval.expr = e;
		    }
break;
case 45:
#line 449 "gram.y"
{ CurrentNamespace = NewNamespace (CurrentNamespace); }
break;
case 46:
#line 452 "gram.y"
{ CurrentNamespace = CurrentNamespace->previous; }
break;
case 47:
#line 455 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 50:
#line 462 "gram.y"
{ yyval.expr = NewExprTree(OC, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 51:
#line 464 "gram.y"
{ yyval.expr = NewExprTree(OC, 0, 0); }
break;
case 52:
#line 467 "gram.y"
{ yyval.expr = NewExprTree(IF, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 53:
#line 469 "gram.y"
{ yyval.expr = NewExprTree(ELSE, yyvsp[-4].expr, NewExprTree(ELSE, yyvsp[-2].expr, yyvsp[0].expr)); }
break;
case 56:
#line 476 "gram.y"
{ yyval.expr = yyvsp[-2].expr; }
break;
case 57:
#line 478 "gram.y"
{ yyval.expr = NewExprTree(WHILE, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 58:
#line 480 "gram.y"
{ yyval.expr = NewExprTree(DO, yyvsp[-6].expr, yyvsp[-3].expr); }
break;
case 59:
#line 482 "gram.y"
{ Expr *expr = ParseCanonFor(yyvsp[-4].expr);
		      if (!expr)
                          YYERROR;
		      yyval.expr = NewExprTree(FOR, expr, yyvsp[-2].expr); }
break;
case 60:
#line 487 "gram.y"
{ yyval.expr = NewExprTree (SWITCH, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 61:
#line 489 "gram.y"
{ yyval.expr = NewExprTree (UNION, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 62:
#line 491 "gram.y"
{ yyval.expr = NewExprTree(BREAK, (Expr *) 0, (Expr *) 0); }
break;
case 63:
#line 493 "gram.y"
{ yyval.expr = NewExprTree(CONTINUE, (Expr *) 0, (Expr *) 0); }
break;
case 64:
#line 495 "gram.y"
{ yyval.expr = NewExprTree (RETURNTOK, (Expr *) 0, yyvsp[-1].expr); }
break;
case 65:
#line 497 "gram.y"
{ yyval.expr = NewExprTree(EXPR, yyvsp[-1].expr, (Expr *) 0); }
break;
case 66:
#line 499 "gram.y"
{ yyval.expr = NewExprTree(SEMI, (Expr *) 0, (Expr *) 0); }
break;
case 67:
#line 501 "gram.y"
{ 
			DeclList    *decl = yyvsp[-3].funcDecl.decl;
			SymbolPtr   symbol = decl->symbol;
			Class	    class = yyvsp[-3].funcDecl.type.class;
			Publish	    publish = yyvsp[-3].funcDecl.type.publish;
			TypePtr	    type = yyvsp[-3].funcDecl.type.type;
			TypePtr	    ret = type->func.ret;
			ArgType	    *argType = type->func.args;

			if (symbol)
			{
			    if (yyvsp[-1].expr)
			    {
				symbol->symbol.forward = False;
				ParseCanonType (ret, False);
				decl->init = NewExprCode (NewFuncCode (ret,
								       argType,
								       yyvsp[-1].expr,
								       yyvsp[-2].value),
							  NewExprAtom (symbol->symbol.name, symbol, False));
			    }
			    else
				symbol->symbol.forward = True;
			}
			yyval.expr = NewExprDecl (FUNC, decl, class, type, publish);
		    }
break;
case 68:
#line 528 "gram.y"
{ 
			DeclListPtr decl;

			decl = NewDeclList (yyvsp[-6].atom, 0, 0);
			decl->symbol = ParseNewSymbol (yyvsp[-9].publish, 
						       class_exception, 
						       typePoly, yyvsp[-6].atom);
			decl->symbol->exception.doc = yyvsp[-2].value;
			yyval.expr = NewExprDecl (EXCEPTION,
					  decl,
					  class_exception,
					  NewTypeFunc (typePoly, yyvsp[-4].argType),
					  yyvsp[-9].publish);
		    }
break;
case 69:
#line 543 "gram.y"
{ yyval.expr = NewExprTree (RAISE, yyvsp[-4].expr, yyvsp[-2].expr); }
break;
case 70:
#line 545 "gram.y"
{ 
			DeclListPtr decl;

			for (decl = yyvsp[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yyvsp[-5].publish, class_typedef,
							   0, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yyvsp[-2].declList, class_typedef, 0, yyvsp[-5].publish), 0);
		    }
break;
case 71:
#line 554 "gram.y"
{ 
			DeclListPtr decl;

			for (decl = yyvsp[-2].declList; decl; decl = decl->next)
			    decl->symbol = ParseNewSymbol (yyvsp[-6].publish, class_typedef,
							   yyvsp[-3].type, decl->name);
			yyval.expr = NewExprTree (TYPEDEF, NewExprDecl (TYPEDEF, yyvsp[-2].declList, class_typedef, yyvsp[-3].type, yyvsp[-6].publish), 0);
		    }
break;
case 72:
#line 563 "gram.y"
{
			SymbolPtr   symbol;
			Publish	    publish = yyvsp[-3].publish;
			
			/*
			 * this is a hack - save the current namespace
			 * on the parser stack to be restored after
			 * the block is compiled.
			 */
			yyvsp[-2].namespace = CurrentNamespace;
			if (publish == publish_extend)
			{
			    symbol = NamespaceFindName (CurrentNamespace, yyvsp[0].atom, True);
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", yyvsp[0].atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", yyvsp[0].atom);
				YYERROR;
			    }
			    else
				CurrentNamespace = symbol->namespace.namespace;
			}
			else
			{
			    symbol = ParseNewSymbol (yyvsp[-3].publish, class_namespace,
						     0, yyvsp[0].atom);
			    CurrentNamespace = NewNamespace (CurrentNamespace);
			    symbol->namespace.namespace = CurrentNamespace;
			}
			/*
			 * Make all of the symbols visible while compiling within
			 * the namespace
			 */
			if (CurrentNamespace != yyvsp[-2].namespace)
			    CurrentNamespace->publish = publish_public;
		    }
break;
case 73:
#line 604 "gram.y"
{
			/*
			 * close the namespace to non-public lookups
			 */
			if (CurrentNamespace != yyvsp[-7].namespace)
			    CurrentNamespace->publish = publish_private;
			/*
			 * Restore to the namespace saved on
			 * the parser stack
			 */
			CurrentNamespace = yyvsp[-7].namespace;
			yyval.expr = NewExprTree (NAMESPACE, NewExprAtom (yyvsp[-5].atom, 0, False), yyvsp[-2].expr);
		    }
break;
case 74:
#line 618 "gram.y"
{
			SymbolPtr	symbol;
			ExprPtr		p, e, n;

			p = yyvsp[-2].expr;
			for (p = yyvsp[-2].expr; p; p = n)
			{
			    if (p->base.tag == COMMA)
			    {
				e = p->tree.left;
				n = p->tree.right;
			    }
			    else
			    {
				e = p;
				n = 0;
			    }
			    if (e->base.tag == COLONCOLON)
				e = e->tree.right;
			    symbol = e->atom.symbol;
			    if (!symbol)
			    {
				ParseError ("non-existant namespace %A", e->atom.atom);
				YYERROR;
			    }
			    else if (symbol->symbol.class != class_namespace)
			    {
				ParseError ("%A is not a namespace", e->atom.atom);
				YYERROR;
			    }
			    NamespaceImport (CurrentNamespace, 
					     symbol->namespace.namespace, yyvsp[-5].publish);
			}
			yyval.expr = NewExprTree (IMPORT, yyvsp[-2].expr, NewExprDecl (IMPORT,
								   0, 
								   class_undef,
								   0,
								   yyvsp[-5].publish));
		    }
break;
case 75:
#line 658 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 76:
#line 660 "gram.y"
{ yyval.expr = NewExprTree (TWIXT, 
					NewExprTree (TWIXT, yyvsp[-6].expr, yyvsp[-4].expr),
					NewExprTree (TWIXT, yyvsp[-2].expr, 0));
		    }
break;
case 77:
#line 666 "gram.y"
{ yyval.expr = NewExprTree(SEMI, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 78:
#line 668 "gram.y"
{ yyval.expr = NewExprTree(SEMI, yyvsp[0].expr, 0); }
break;
case 80:
#line 673 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 81:
#line 676 "gram.y"
{ yyval.expr = NewExprTree (CATCH, yyvsp[0].expr, yyvsp[-1].expr); }
break;
case 82:
#line 680 "gram.y"
{ yyval.expr = NewExprTree (CATCH, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 83:
#line 682 "gram.y"
{ yyval.expr = 0; }
break;
case 84:
#line 685 "gram.y"
{ yyval.expr = NewExprCode (NewFuncCode (typePrim[rep_void],
						     yyvsp[-3].argType, yyvsp[-1].expr, yyvsp[-2].value),
					yyvsp[-5].expr); 
		    }
break;
case 86:
#line 692 "gram.y"
{ yyval.expr = 0; }
break;
case 87:
#line 694 "gram.y"
{ ++funcDepth; }
break;
case 88:
#line 694 "gram.y"
{ --funcDepth; yyval.expr = yyvsp[0].expr; }
break;
case 89:
#line 697 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 90:
#line 699 "gram.y"
{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yyvsp[-1].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 93:
#line 709 "gram.y"
{ seeComment = 1; }
break;
case 94:
#line 712 "gram.y"
{ seeComment = 0; yyval.value = yyvsp[0].value; }
break;
case 96:
#line 716 "gram.y"
{ yyval.value = Void; }
break;
case 97:
#line 719 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 98:
#line 722 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 99:
#line 724 "gram.y"
{ yyval.expr = 0; }
break;
case 100:
#line 727 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 101:
#line 729 "gram.y"
{ yyval.expr = NewExprTree (CASE, 0, yyvsp[0].expr); }
break;
case 102:
#line 732 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 103:
#line 735 "gram.y"
{ yyval.expr = NewExprTree (CASE, yyvsp[-1].expr, yyvsp[0].expr); }
break;
case 104:
#line 737 "gram.y"
{ yyval.expr = 0; }
break;
case 105:
#line 740 "gram.y"
{ 
			SymbolPtr   sym = yyvsp[-3].symbol;
			Atom	    sym_atom = sym ? sym->symbol.name : 0;
			ExprPtr	    name = 0;
			
			if (sym)
			    name = NewExprAtom (sym_atom, sym, False);
			    
			yyval.expr = NewExprTree (CASE, 
					  NewExprTree (CASE,
						       NewExprAtom (yyvsp[-4].atom, 0, False),
						       name),
					  yyvsp[-1].expr);
		    }
break;
case 106:
#line 755 "gram.y"
{ yyval.expr = NewExprTree (CASE, 0, yyvsp[0].expr); }
break;
case 107:
#line 758 "gram.y"
{
			yyval.symbol = ParseNewSymbol (publish_private,
					     class_undef,
					     typePoly,
					     yyvsp[0].atom);
		    }
break;
case 108:
#line 765 "gram.y"
{ yyval.symbol = 0; }
break;
case 109:
#line 771 "gram.y"
{ yyval.atomList = NewAtomList (yyvsp[0].atomList, yyvsp[-2].atom); }
break;
case 110:
#line 773 "gram.y"
{ yyval.atomList = NewAtomList (0, yyvsp[0].atom); }
break;
case 111:
#line 776 "gram.y"
{ yyval.declList = NewDeclList (yyvsp[-2].atom, 0, yyvsp[0].declList); }
break;
case 112:
#line 778 "gram.y"
{ yyval.declList = NewDeclList (yyvsp[0].atom, 0, 0); }
break;
case 115:
#line 792 "gram.y"
{ 
			if (yyvsp[-3].symbol)
			{
			    yyval.declList = NewDeclList (yyvsp[-3].symbol->symbol.name, yyvsp[-2].expr, yyvsp[0].declList); 
			    yyval.declList->symbol = yyvsp[-3].symbol;
			}
			else
			    yyval.declList = yyvsp[0].declList;
		    }
break;
case 116:
#line 802 "gram.y"
{ 
			if (yyvsp[-1].symbol)
			{
			    yyval.declList = NewDeclList (yyvsp[-1].symbol->symbol.name, yyvsp[0].expr, 0);
			    yyval.declList->symbol = yyvsp[-1].symbol;
			}
			else
			    yyvsp[-1].symbol = 0;
		    }
break;
case 117:
#line 813 "gram.y"
{	
			yyval.symbol = ParseNewSymbol (yyvsp[-1].fulltype.publish,
					     yyvsp[-1].fulltype.class,
					     yyvsp[-1].fulltype.type,
					     yyvsp[0].atom);
		    }
break;
case 118:
#line 825 "gram.y"
{ yyval.fulltype = yyvsp[-3].fulltype; }
break;
case 119:
#line 831 "gram.y"
{
			NamespacePtr	save = CurrentNamespace;
			SymbolPtr	symbol;
			Type		*type = NewTypeFunc (yyvsp[-3].funcDecl.type.type, yyvsp[-1].argType);
			/*
			 * namespace_start pushed a new namespace, make sure
			 * this symbol is placed in the original namespace
			 */
			CurrentNamespace = save->previous;
			symbol = NamespaceFindName (CurrentNamespace, yyvsp[-3].funcDecl.decl->name, True);
			if (symbol && symbol->symbol.forward)
			{
			    if (!TypeIsSupertype (symbol->symbol.type, type))
			    {
				ParseError ("%A redefinition with different type",
					    yyvsp[-3].funcDecl.decl->name);
				symbol = 0;
			    }
			}
			else
			{
			    symbol = ParseNewSymbol (yyvsp[-3].funcDecl.type.publish,
						     yyvsp[-3].funcDecl.type.class, 
						     type,
						     yyvsp[-3].funcDecl.decl->name);
			}
			CurrentNamespace = save;
			yyval.funcDecl = yyvsp[-3].funcDecl;
			yyval.funcDecl.decl->symbol = symbol;
			yyval.funcDecl.type.type = type;
		    }
break;
case 120:
#line 864 "gram.y"
{ yyval.funcDecl.type = yyvsp[-2].fulltype; yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); }
break;
case 121:
#line 866 "gram.y"
{ yyval.funcDecl.type = yyvsp[-3].fulltype; yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); }
break;
case 122:
#line 868 "gram.y"
{ 
			yyval.funcDecl.type.publish = publish_private;
			yyval.funcDecl.type.class = class_undef;
			yyval.funcDecl.type.type = typePoly;
			yyval.funcDecl.decl = NewDeclList (yyvsp[-1].atom, 0, 0); 
		    }
break;
case 123:
#line 876 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 124:
#line 878 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 125:
#line 880 "gram.y"
{ yyval.expr = 0; }
break;
case 126:
#line 886 "gram.y"
{ yyval.fulltype.publish = yyvsp[-3].publish; yyval.fulltype.class = yyvsp[-2].class; yyval.fulltype.type = yyvsp[-1].type; }
break;
case 127:
#line 888 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = yyvsp[-2].class; yyval.fulltype.type = yyvsp[-1].type; }
break;
case 128:
#line 890 "gram.y"
{ yyval.fulltype.publish = publish_private; yyval.fulltype.class = class_undef; yyval.fulltype.type = yyvsp[-1].type; }
break;
case 129:
#line 896 "gram.y"
{ yyval.type = NewTypeFunc (yyvsp[0].type, yyvsp[-1].argType); }
break;
case 130:
#line 898 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, False); }
break;
case 131:
#line 900 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, True); }
break;
case 132:
#line 902 "gram.y"
{ yyval.type = NewTypeArray (yyvsp[0].type, yyvsp[-2].expr, False); }
break;
case 133:
#line 904 "gram.y"
{ yyval.type = NewTypeHash (yyvsp[0].type, yyvsp[-2].type); }
break;
case 134:
#line 906 "gram.y"
{ yyval.type = 0; }
break;
case 135:
#line 909 "gram.y"
{
			Type	*top = yyvsp[0].type;
			Type	*t, **bot = &top;

			/*
			 * Walk down the type chain to hang the
			 * base type off of the end.  This
			 * makes int[]() be an array of functions
			 * rather than a function returning an array
			 */
			while ((t = *bot))
			    switch (t->base.tag) {
			    case type_array:
				bot = &t->array.type;
				break;
			    case type_hash:
				bot = &t->hash.type;
				break;
			    case type_func:
				bot = &t->func.ret;
				break;
			    default:
				assert(0);
			    }
			*bot = yyvsp[-1].type;
			yyval.type = top;
		    }
break;
case 136:
#line 937 "gram.y"
{ yyval.type = NewTypeRef (yyvsp[0].type, True); }
break;
case 137:
#line 939 "gram.y"
{ yyval.type = NewTypeRef (NewTypeRef (yyvsp[0].type, True), True); }
break;
case 138:
#line 941 "gram.y"
{ yyval.type = NewTypeRef (NewTypeRef (yyvsp[0].type, False), False); }
break;
case 139:
#line 943 "gram.y"
{ yyval.type = NewTypeRef (yyvsp[0].type, False); }
break;
case 141:
#line 947 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeStruct (st);
		    }
break;
case 142:
#line 973 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			MemListPtr	ml;
			int		nelements;

			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
				nelements++;
			}
			st = NewStructType (nelements);
			nelements = 0;
			for (ml = yyvsp[-1].memList; ml; ml = ml->next)
			{
			    for (al = ml->atoms; al; al = al->next)
			    {
				AddBoxType (&st->types, ml->type);
				StructTypeAtoms(st)[nelements] = al->atom;
				nelements++;
			    }
			}
			yyval.type = NewTypeUnion (st, False);
		    }
break;
case 143:
#line 999 "gram.y"
{
			AtomListPtr	al;
			StructType	*st;
			int		nelements;

			nelements = 0;
			for (al = yyvsp[-1].atomList; al; al = al->next)
			    nelements++;
			
			st = NewStructType (nelements);
			nelements = 0;
			for (al = yyvsp[-1].atomList; al; al = al->next)
			{
			    AddBoxType (&st->types, typePrim[rep_void]);
			    StructTypeAtoms(st)[nelements] = al->atom;
			    nelements++;
			}
			yyval.type = NewTypeUnion (st, True);
		    }
break;
case 144:
#line 1020 "gram.y"
{ yyval.type = yyvsp[-1].type; }
break;
case 145:
#line 1022 "gram.y"
{ yyval.type = NewTypeName (yyvsp[0].expr, 0); }
break;
case 147:
#line 1026 "gram.y"
{ yyval.type = typePoly; }
break;
case 162:
#line 1044 "gram.y"
{ yyval.expr = 0; }
break;
case 163:
#line 1047 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[-2].expr); }
break;
case 164:
#line 1049 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 165:
#line 1052 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[-2].expr); }
break;
case 166:
#line 1054 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, 0); }
break;
case 167:
#line 1057 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 168:
#line 1059 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 169:
#line 1065 "gram.y"
{ yyval.memList = NewMemList (yyvsp[-2].atomList, yyvsp[-3].type, yyvsp[0].memList); }
break;
case 170:
#line 1067 "gram.y"
{ yyval.memList = 0; }
break;
case 171:
#line 1070 "gram.y"
{ yyval.memList = NewMemList (yyvsp[-2].atomList, yyvsp[-3].type, yyvsp[0].memList); }
break;
case 172:
#line 1072 "gram.y"
{ yyval.memList = 0; }
break;
case 174:
#line 1079 "gram.y"
{ yyval.class = class_undef; }
break;
case 180:
#line 1088 "gram.y"
{ yyval.publish = publish_private; }
break;
case 185:
#line 1102 "gram.y"
{ yyval.argType = yyvsp[-1].argType; }
break;
case 186:
#line 1104 "gram.y"
{ yyval.argType = 0; }
break;
case 187:
#line 1107 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-2].argDecl.type, False, yyvsp[-2].argDecl.name, 0, yyvsp[0].argType); }
break;
case 188:
#line 1109 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-1].argDecl.type, yyvsp[0].bool, yyvsp[-1].argDecl.name, 0, 0); }
break;
case 189:
#line 1112 "gram.y"
{ 
			ParseCanonType (yyvsp[-1].type, False);
			yyval.argDecl.type = yyvsp[-1].type; 
			yyval.argDecl.name = yyvsp[0].atom; 
		    }
break;
case 190:
#line 1118 "gram.y"
{ 
			ParseCanonType (yyvsp[0].type, False);
			yyval.argDecl.type = yyvsp[0].type;
			yyval.argDecl.name = 0; 
		    }
break;
case 191:
#line 1129 "gram.y"
{ yyval.argType = yyvsp[-1].argType; }
break;
case 192:
#line 1132 "gram.y"
{
			ArgType	*args;
			Type	*type;

			for (args = yyvsp[0].argType; args; args = args->next)
			{
			    type = args->type;
			    if (ParseCanonType (type, False) != CanonTypeDefined)
				break;
			    if (args->varargs)
			    {
				type = NewTypeArray (type,
						     NewExprTree (COMMA,
								  NewExprConst (TEN_NUM, 
										NewInt (0)),
								  0),
						     False);
			    }
			    args->symbol = ParseNewSymbol (publish_private,
							   class_arg, 
							   type, args->name);
			}
			yyval.argType = yyvsp[0].argType;
		    }
break;
case 193:
#line 1157 "gram.y"
{ yyval.argType = 0; }
break;
case 194:
#line 1160 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-2].argDecl.type, False, yyvsp[-2].argDecl.name, 0, yyvsp[0].argType); }
break;
case 195:
#line 1162 "gram.y"
{ yyval.argType = NewArgType (yyvsp[-1].argDecl.type, yyvsp[0].bool, yyvsp[-1].argDecl.name, 0, 0); }
break;
case 196:
#line 1165 "gram.y"
{ yyval.argDecl.type = yyvsp[-1].type; yyval.argDecl.name = yyvsp[0].atom; }
break;
case 197:
#line 1167 "gram.y"
{ yyval.argDecl.type = yyvsp[0].type; yyval.argDecl.name = 0; }
break;
case 198:
#line 1170 "gram.y"
{ yyval.bool = True; }
break;
case 199:
#line 1172 "gram.y"
{ yyval.bool = False; }
break;
case 201:
#line 1180 "gram.y"
{ yyval.expr = 0; }
break;
case 203:
#line 1184 "gram.y"
{ 
			DeclList    *decl;

			for (decl = yyvsp[0].declList; decl; decl = decl->next)
			{
			    if (decl->init)
			    {
				if (!decl->init->base.type)
				    decl->init->base.type = yyvsp[-1].fulltype.type;
			    }
			}

			yyval.expr = NewExprDecl (VAR, yyvsp[0].declList, yyvsp[-1].fulltype.class, yyvsp[-1].fulltype.type, yyvsp[-1].fulltype.publish); 
		    }
break;
case 205:
#line 1201 "gram.y"
{ yyval.expr = NewExprTree(COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 207:
#line 1208 "gram.y"
{ yyval.expr = 0; }
break;
case 208:
#line 1211 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 209:
#line 1213 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[0].expr, 0); }
break;
case 211:
#line 1217 "gram.y"
{ yyval.expr = 0; }
break;
case 212:
#line 1220 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 213:
#line 1222 "gram.y"
{	
			ExprPtr	arg = yyvsp[0].bool ? NewExprTree (DOTDOTDOT, yyvsp[-1].expr, 0) : yyvsp[-1].expr;
			yyval.expr = NewExprTree (COMMA, arg, 0); 
		    }
break;
case 214:
#line 1228 "gram.y"
{ 
			yyval.expr = NewExprTree (OC,
					  NewExprTree (RETURNTOK, 0, yyvsp[0].expr),
					  NewExprTree (OC, 0, 0));
		    }
break;
case 215:
#line 1233 "gram.y"
{ ++funcDepth; }
break;
case 216:
#line 1233 "gram.y"
{ --funcDepth; yyval.expr = yyvsp[0].expr; }
break;
case 217:
#line 1239 "gram.y"
{ 
			if (yyvsp[-1].ints == ASSIGNPOW)
			    yyval.expr = NewExprTree (ASSIGNPOW, 
					      BuildName ("Math", "assign_pow"),
					      NewExprTree (ASSIGNPOW, yyvsp[-2].expr, yyvsp[0].expr));
			else
			{
			    ExprPtr left = yyvsp[-2].expr;
			    /*
			     * Automatically declare names used in
			     * simple assignements at the top level
			     */
			    if (yyvsp[-1].ints == ASSIGN && 
				funcDepth == 0 &&
				left->base.tag == NAME && 
				!(left->atom.symbol))
			    {
				yyvsp[-2].expr->atom.symbol = ParseNewSymbol (publish_private,
								  class_undef, 
								  typePoly, 
								  yyvsp[-2].expr->atom.atom);
			    }
			    yyval.expr = NewExprTree(yyvsp[-1].ints, yyvsp[-2].expr, yyvsp[0].expr); 
			}
		    }
break;
case 218:
#line 1265 "gram.y"
{
			ParseCanonType (yyvsp[-6].type, False);
			yyval.expr = NewExprCode (NewFuncCode (yyvsp[-6].type, yyvsp[-3].argType, yyvsp[-1].expr, yyvsp[-2].value), 0); 
		    }
break;
case 219:
#line 1270 "gram.y"
{   Value	t;
			t = do_Thread_id_to_thread (yyvsp[0].value);
			if (t == Void)
			{
			    ParseError ("No thread %v", yyvsp[0].value);
			    YYERROR;
			}
			else
			    yyval.expr = NewExprConst(THREAD_CONST, t); 
		    }
break;
case 220:
#line 1281 "gram.y"
{ yyval.expr = NewExprTree(STAR, yyvsp[0].expr, (Expr *) 0); }
break;
case 221:
#line 1283 "gram.y"
{ yyval.expr = NewExprTree(STAR, NewExprTree (STAR, yyvsp[0].expr, 0), 0); }
break;
case 222:
#line 1285 "gram.y"
{ yyval.expr = NewExprTree(AMPER, yyvsp[0].expr, (Expr *) 0); }
break;
case 223:
#line 1287 "gram.y"
{ yyval.expr = NewExprTree(AMPER, 
				       NewExprTree (AMPER, yyvsp[0].expr, (Expr *) 0), 
				       (Expr *) 0); }
break;
case 224:
#line 1291 "gram.y"
{ yyval.expr = NewExprTree(UMINUS, yyvsp[0].expr, (Expr *) 0); }
break;
case 225:
#line 1293 "gram.y"
{ yyval.expr = NewExprTree(LNOT, yyvsp[0].expr, (Expr *) 0); }
break;
case 226:
#line 1295 "gram.y"
{ yyval.expr = NewExprTree(BANG, yyvsp[0].expr, (Expr *) 0); }
break;
case 227:
#line 1297 "gram.y"
{ yyval.expr = NewExprTree(FACT, yyvsp[-1].expr, (Expr *) 0); }
break;
case 228:
#line 1299 "gram.y"
{ yyval.expr = NewExprTree(INC, yyvsp[0].expr, (Expr *) 0); }
break;
case 229:
#line 1301 "gram.y"
{ yyval.expr = NewExprTree(INC, (Expr *) 0, yyvsp[-1].expr); }
break;
case 230:
#line 1303 "gram.y"
{ yyval.expr = NewExprTree(DEC, yyvsp[0].expr, (Expr *) 0); }
break;
case 231:
#line 1305 "gram.y"
{ yyval.expr = NewExprTree(DEC, (Expr *) 0, yyvsp[-1].expr); }
break;
case 232:
#line 1307 "gram.y"
{ yyval.expr = NewExprTree (FORK, (Expr *) 0, yyvsp[0].expr); }
break;
case 233:
#line 1309 "gram.y"
{ yyval.expr = NewExprTree(PLUS, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 234:
#line 1311 "gram.y"
{ yyval.expr = NewExprTree(MINUS, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 235:
#line 1313 "gram.y"
{ yyval.expr = NewExprTree(TIMES, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 236:
#line 1315 "gram.y"
{ yyval.expr = NewExprTree(DIVIDE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 237:
#line 1317 "gram.y"
{ yyval.expr = NewExprTree(DIV, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 238:
#line 1319 "gram.y"
{ yyval.expr = NewExprTree(MOD, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 239:
#line 1321 "gram.y"
{ 
			yyval.expr = NewExprTree(POW, 
					 BuildName ("Math", "pow"), 
					 NewExprTree (POW, yyvsp[-2].expr, yyvsp[0].expr)); 
		    }
break;
case 240:
#line 1327 "gram.y"
{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yyvsp[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(2))));
		    }
break;
case 241:
#line 1335 "gram.y"
{
			yyval.expr = NewExprTree (POW,
					  BuildName("Math", "pow"),
					  NewExprTree (POW, yyvsp[-1].expr,
						       NewExprConst (TEN_NUM,
								     NewInt(3))));
		    }
break;
case 242:
#line 1343 "gram.y"
{ yyval.expr = NewExprTree(SHIFTL, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 243:
#line 1345 "gram.y"
{ yyval.expr = NewExprTree(SHIFTR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 244:
#line 1347 "gram.y"
{ yyval.expr = NewExprTree(QUEST, yyvsp[-4].expr, NewExprTree(COLON, yyvsp[-2].expr, yyvsp[0].expr)); }
break;
case 245:
#line 1349 "gram.y"
{ yyval.expr = NewExprTree(LXOR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 246:
#line 1351 "gram.y"
{ yyval.expr = NewExprTree(LAND, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 247:
#line 1353 "gram.y"
{ yyval.expr = NewExprTree(LOR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 248:
#line 1355 "gram.y"
{ yyval.expr = NewExprTree(AND, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 249:
#line 1357 "gram.y"
{ yyval.expr = NewExprTree(OR, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 250:
#line 1359 "gram.y"
{ yyval.expr = NewExprTree(EQ, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 251:
#line 1361 "gram.y"
{ yyval.expr = NewExprTree(NE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 252:
#line 1363 "gram.y"
{ yyval.expr = NewExprTree(LT, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 253:
#line 1365 "gram.y"
{ yyval.expr = NewExprTree(GT, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 254:
#line 1367 "gram.y"
{ yyval.expr = NewExprTree(LE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 255:
#line 1369 "gram.y"
{ yyval.expr = NewExprTree(GE, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 257:
#line 1372 "gram.y"
{ yyval.expr = NewExprConst(TEN_NUM, yyvsp[0].value); }
break;
case 258:
#line 1374 "gram.y"
{ yyval.expr = NewExprConst(OCTAL_NUM, yyvsp[0].value); }
break;
case 259:
#line 1376 "gram.y"
{ yyval.expr = NewExprConst(OCTAL0_NUM, yyvsp[0].value); }
break;
case 260:
#line 1378 "gram.y"
{ yyval.expr = NewExprConst(BINARY_NUM, yyvsp[0].value); }
break;
case 261:
#line 1380 "gram.y"
{ yyval.expr = NewExprConst(HEX_NUM, yyvsp[0].value); }
break;
case 262:
#line 1382 "gram.y"
{ yyval.expr = NewExprConst(TEN_FLOAT, yyvsp[0].value); }
break;
case 263:
#line 1384 "gram.y"
{ yyval.expr = NewExprConst(OCTAL_FLOAT, yyvsp[0].value); }
break;
case 264:
#line 1386 "gram.y"
{ yyval.expr = NewExprConst(OCTAL0_FLOAT, yyvsp[0].value); }
break;
case 265:
#line 1388 "gram.y"
{ yyval.expr = NewExprConst(BINARY_FLOAT, yyvsp[0].value); }
break;
case 266:
#line 1390 "gram.y"
{ yyval.expr = NewExprConst(HEX_FLOAT, yyvsp[0].value); }
break;
case 267:
#line 1392 "gram.y"
{ yyval.expr = NewExprConst(CHAR_CONST, yyvsp[0].value); }
break;
case 268:
#line 1394 "gram.y"
{ yyval.expr = NewExprConst(STRING_CONST, yyvsp[0].value); }
break;
case 269:
#line 1396 "gram.y"
{ yyval.expr = NewExprConst(VOIDVAL, yyvsp[0].value); }
break;
case 270:
#line 1398 "gram.y"
{ yyval.expr = NewExprConst(BOOLVAL, yyvsp[0].value); }
break;
case 271:
#line 1400 "gram.y"
{ 
			yyval.expr = BuildFullname (0, AtomId ("[]"));
		    }
break;
case 272:
#line 1404 "gram.y"
{ 
			ParseCanonType (yyvsp[-4].type, False);
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = yyvsp[-4].type;
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0);
			yyval.expr->base.type = yyvsp[-4].type;
		    }
break;
case 273:
#line 1412 "gram.y"
{ 
			yyvsp[-1].expr->base.type = NewTypeArray (typePoly, yyvsp[-5].expr, True); 
			ParseCanonType (yyvsp[-1].expr->base.type, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0); 
			yyval.expr->base.type = yyvsp[-1].expr->base.type;
		    }
break;
case 274:
#line 1419 "gram.y"
{ 
			TypePtr	t = NewTypeArray (typePoly, yyvsp[-5].expr, False);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0); 
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
break;
case 275:
#line 1428 "gram.y"
{
			TypePtr t = NewTypeHash (typePoly, yyvsp[-5].type);
			ParseCanonType (t, False);
			yyval.expr = NewExprTree (NEW, yyvsp[-1].expr, 0);
			if (yyvsp[-1].expr)
			    yyvsp[-1].expr->base.type = t;
			yyval.expr->base.type = t;
		    }
break;
case 276:
#line 1437 "gram.y"
{
			ParseCanonType (yyvsp[-2].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yyvsp[0].atom, 0, False), 0); 
			yyval.expr->base.type = yyvsp[-2].type;
		    }
break;
case 277:
#line 1443 "gram.y"
{ 
			ParseCanonType (yyvsp[-4].type, False);
			yyval.expr = NewExprTree (UNION, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); 
			yyval.expr->base.type = yyvsp[-4].type;
		    }
break;
case 278:
#line 1449 "gram.y"
{ yyval.expr = BuildCall ("History", "fetch", 1, NewExprConst (TEN_NUM, yyvsp[0].value)); }
break;
case 279:
#line 1451 "gram.y"
{ yyval.expr = NewExprTree (DOLLAR, 0, 0); }
break;
case 280:
#line 1453 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 281:
#line 1455 "gram.y"
{ yyval.expr = yyvsp[-1].expr; }
break;
case 282:
#line 1457 "gram.y"
{ yyval.expr = NewExprTree (OS, NewExprTree (STAR, yyvsp[-3].expr, (Expr *) 0), yyvsp[-1].expr); }
break;
case 283:
#line 1459 "gram.y"
{ yyval.expr = NewExprTree(OS, yyvsp[-3].expr, yyvsp[-1].expr); }
break;
case 284:
#line 1461 "gram.y"
{ yyval.expr = NewExprTree (OP, yyvsp[-3].expr, yyvsp[-1].expr); }
break;
case 285:
#line 1463 "gram.y"
{ yyval.expr = NewExprTree(DOT, yyvsp[-2].expr, NewExprAtom (yyvsp[0].atom, 0, False)); }
break;
case 286:
#line 1465 "gram.y"
{ yyval.expr = NewExprTree(ARROW, yyvsp[-2].expr, NewExprAtom (yyvsp[0].atom, 0, False)); }
break;
case 288:
#line 1469 "gram.y"
{ yyval.value = Zero; }
break;
case 308:
#line 1495 "gram.y"
{ yyval.expr = 0; }
break;
case 309:
#line 1497 "gram.y"
{ yyval.expr = 0; }
break;
case 310:
#line 1500 "gram.y"
{ 
			ExprPtr	elts = yyvsp[-3].expr ? ExprRehang (yyvsp[-3].expr, 0) : 0;
			if (yyvsp[-1].bool)
			{
			    ExprPtr i = elts;
			    while (i->tree.right)
				i = i->tree.right;
			    i->tree.right = NewExprTree (COMMA, 
							 NewExprTree (DOTDOTDOT, 0, 0),
							 0);
			}
			yyval.expr = NewExprTree (ARRAY, elts, 0); 
		    }
break;
case 311:
#line 1514 "gram.y"
{
			yyval.expr = NewExprTree (COMP, NewExprTree (COMP, yyvsp[-5].expr, yyvsp[-4].expr), yyvsp[-2].expr);
		    }
break;
case 312:
#line 1519 "gram.y"
{ yyval.expr = yyvsp[0].expr; }
break;
case 314:
#line 1523 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 316:
#line 1527 "gram.y"
{ 
			SymbolPtr   s;
			s = ParseNewSymbol (publish_private, class_arg, 
					    typePrim[rep_integer], yyvsp[0].atom);
			yyval.expr = NewExprAtom (yyvsp[0].atom, s, False); 
		    }
break;
case 317:
#line 1535 "gram.y"
{
			SymbolPtr   s;
			Atom	    a = AtomId("[]");
			s = ParseNewSymbol (publish_private, class_undef,
					    typePoly, a);
			yyval.expr = NewExprAtom (a, s, False);
		    }
break;
case 318:
#line 1544 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 319:
#line 1546 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 323:
#line 1557 "gram.y"
{ yyval.expr = 0; }
break;
case 324:
#line 1559 "gram.y"
{ yyval.expr = 0; }
break;
case 325:
#line 1562 "gram.y"
{
			ExprPtr elts = yyvsp[-2].expr ? ExprRehang (yyvsp[-2].expr, 0) : 0;
			yyval.expr = NewExprTree (HASH, elts, 0);
		    }
break;
case 326:
#line 1568 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 327:
#line 1570 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 328:
#line 1573 "gram.y"
{ yyval.expr = NewExprTree (DARROW, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 329:
#line 1575 "gram.y"
{ yyval.expr = NewExprTree (DARROW, 0, yyvsp[0].expr); }
break;
case 332:
#line 1584 "gram.y"
{ yyval.expr = NewExprTree (STRUCT, ExprRehang (yyvsp[-2].expr, 0), 0); }
break;
case 333:
#line 1587 "gram.y"
{ yyval.expr = NewExprTree (COMMA, yyvsp[-2].expr, yyvsp[0].expr); }
break;
case 334:
#line 1589 "gram.y"
{ yyval.expr = NewExprTree (COMMA, 0, yyvsp[0].expr); }
break;
case 335:
#line 1592 "gram.y"
{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); }
break;
case 336:
#line 1594 "gram.y"
{ yyval.expr = NewExprTree (ASSIGN, NewExprAtom (yyvsp[-2].atom, 0, False), yyvsp[0].expr); }
break;
case 340:
#line 1601 "gram.y"
{ yyval.expr = NewExprTree (ANONINIT, 0, 0); }
break;
#line 4636 "gram.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
